<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display the top articles list
	' IN  : iTop (int) : number of results wanted
	'     : sSortedField (string) : field sorted
	'     : bAscSort (boolean) : if true = ASC sort, else DESC
	' OUT : -
	Sub DisplayAdminTopArticles(iTop, sSortedField, bAscSort)
		Dim oCn, oRs, oRs2, rSQL, iLine, sSortDesc, iNbPages
		
		Select Case LCase(sSortedField)
			Case "artitle" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_TITLE")
			Case "ardate" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_DATE")
			Case "arauthor" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_DATE")
			Case Else :
				' default value
				sSortedField = "arDate"
				bAscSort = False
				sSortDesc = GetTranslation("LANG_DATE")
		End Select

		Set oCn = DBConnexion(DB_MAIN)
		
		If iTop <> 0 and iTop <> "" Then
			rSQL = "SELECT TOP " & iTop & " arID, arTitle, arDate, arAuthor, arDate FROM articles ORDER BY " & sSortedField
		Else
			rSQL = "SELECT arID, arTitle, arDate, arAuthor, arDate FROM articles, articlespages ORDER BY " & sSortedField
		End If

		If Not bAscSort Then
			rSQL = rSQL & " DESC"
			sSortDesc = sSortDesc & " (DESC)"
		Else
			sSortDesc = sSortDesc & " (ASC)"
		End If

		CreateTopTable "TopArticles", GetTranslation("LANG_TOP") & " " & iTop & " - " & GetTranslation("LANG_ARTICLES") & "&nbsp;|&nbsp;<span class=""small"">" & Replace(GetTranslation("LANG_SORT_BY"), "%1%", sSortDesc)  & "</span>"

		Set oRs = DBRecordSet(oCn, rSQL)

		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>"
		SortMenu GetTranslation("LANG_TITLE"), "arTitle", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">"
		SortMenu GetTranslation("LANG_AUTHOR"), "arAuthor", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">"
		SortMenu GetTranslation("LANG_DATE"), "arDate", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
		Response.Write "   </tr>" & vbCRLF

		iLine = 1
		While Not oRs.EOF
			rSQL = "SELECT Max(apHits) As NbHits, Count(apHits) as NbPages FROM articlespages where apArticle=" & oRs("arID")
			Set oRs2 = DBRecordSet(oCn, rSQL)
			If oRs2("NbPages") > 0 Then
				iNbPages = oRs2(0)
			Else
				iNbPages = 0
			End If
			Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
			Response.Write "    <td>" & oRs("arTitle") & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & oRs("arAuthor") & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & GetDateDDMMYYYY(StringToDate(oRs("arDate"))) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & iNbPages & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & vbCRLF
			MenuAdmin(oRs("arID"))
			Response.Write "    </td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF

			iLine = 1 + ((iLine-1) XOR 1)
			oRs.MoveNext
		WEnd

		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""5""><a href=""" & sURLPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_ARTICLE") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display information for a specific article
	' IN  : iID (int) : article's id (table articles, field arID)
	' OUT : -
	Sub DisplayAdminArticle(iID)
		Dim oCn, oRs, rSQL, sDate, sAuthor, sTitle, sDescription, sCatTitle, sVersion, bValid, iNum

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT arID, arDate, arAuthor, arTitle, arDescription, arValid, cTitle, vCode FROM articles, categories, versions WHERE arCategory=cID AND arVersion=vID AND arID=" & iID

		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Then
			CreateTopTable "Article", GetTranslation("LANG_ARTICLE")
			sDate = oRs("arDate")
			sAuthor = oRs("arAuthor")
			sTitle = oRs("arTitle")
			sDescription = oRs("arDescription")
			sCatTitle = oRs("cTitle")
			sVersion = oRs("vCode")
			bValid = oRs("arValid")
	
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "	<td>" & CodeMessage(sTitle, True) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
			Response.Write "	<td>" & CodeMessage(sDescription, True) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			Response.Write "	<td>" & GetDateDDMMYYYY(StringToDate(sDate)) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(sCatTitle) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(sVersion) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_ARTICLE_PAGES") & "</td>" & vbCRLF
			Response.Write "    <td>" & vbCRLF

			rSQL = "SELECT apID, apTitle, apHits FROM ArticlesPages WHERE apArticle=" & iID & " ORDER BY apID"

			Set oRs = DBRecordSet(oCn, rSQL)
			iNum = 0
			If Not oRs.EOF Then
				While Not oRs.EOF
					Response.Write "      " & iNum+1 & ". <a href=""" & GLOBAL_SITE_ARTICLES_PAGES_PAGE & "?id=" & oRs("apID") & "&article=" & iID & "&do=view"">" & oRs("apTitle") & "</a> (" & oRs("apHits") & ")<br>" & vbCRLF
					iNum = iNum + 1
					oRs.MoveNext
				WEnd
			Else
				Response.Write "      -" & vbCRLF
			End If
			
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
			Response.Write "    <td>" & bValid & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2""><a href=""" & GLOBAL_SITE_ARTICLES_PAGES_PAGE & "?article=" & iID & """>" & GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_ARTICLE_PAGES") & "</a></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
		
			CreateBottomTable ""
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display search's result on articles
	' IN  : sQuery (string) : query data
	' OUT : -
	Sub DisplayAdminArticlesSearch(sQuery)
		Dim oCn, oRs, rSQL, iLine
		
		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT arID, arTitle, arDate, arAuthor, arDate, max(apHits) as NbPages FROM articles, articlespages WHERE apArticle=arID AND arTitle LIKE '" & SQLEncrypt(sQuery) & "' GROUP BY arID, arTitle, arDate, arAuthor, arDate"

		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "SearchArticles", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_ARTICLES") & " (" & Server.HTMLEncode(Replace(sQuery, "%", "")) & ")"

		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
		Response.Write "   </tr>" & vbCRLF

		iLine = 1
		While Not oRs.EOF
			Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
			Response.Write "    <td>" & oRs("arTitle") & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & oRs("arAuthor") & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & GetDateDDMMYYYY(StringToDate(oRs("arDate"))) & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & oRs("NbPages") & "</td>" & vbCRLF
			Response.Write "    <td align=""center"">" & vbCRLF
			MenuAdmin(oRs("arID"))
			Response.Write "    </td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF

			iLine = 1 + ((iLine-1) XOR 1)
			oRs.MoveNext
		WEnd

		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""5""><a href=""" & sURLPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_ARTICLE") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF

		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display a navigation bar for articles
	' IN  : -
	' OUT : -
	Sub DisplayAdminArticlesNavigation()
		Dim X
		
		CreateTopTable "SearchArticles", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_ARTICLES")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <form name=""Search"" method=""get"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "    <input type=""hidden"" name=""Do"" value=""search"">" & vbCRLF
		Response.Write "    <td><a href=""" & sURLPage & """>" & GetTranslation("LANG_TOP") & "</a>" & vbCRLF
		For X = 0 to 25
			Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=" & Chr(Asc("a")+X) & """>" & Chr(Asc("a")+X) & "</a>" & vbCRLF
		Next
		Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=0"">0-9</a>" & vbCRLF
		Response.Write "    &nbsp;<input name=""name"" size=""10"" maxlength=""20"" class=""cell"" onEnter=""javascript:document.search.submit()""></td>"
		Response.Write "    </form>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
	End Sub

	' Display edit article's form (add or update data)
	' IN  : iID (int) : article's id (table articles, field arID), if null or = 0 then add article
	' OUT : -
	Sub EditArticle(iID)
		Dim oCn, oRs, rSQL
		Dim sEditTitle, sDo, sTitle, dDate, sAuthor, sDescription, iCategory, iVersion, bValid

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sDo = "updt"
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_ARTICLE")
			rSQL = "SELECT * FROM articles WHERE arID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sTitle = oRs("arTitle")
				dDate = oRs("arDate")
				sDescription = oRs("arDescription")
				sAuthor = oRs("arAuthor")
				iCategory = oRs("arCategory")
				iVersion = oRs("arVersion")
				bValid = oRs.Fields("arValid").Value
			End If
		Else
			sDo = "add"
			sEditTitle = GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_ARTICLE")
			sTitle = ""
			dDate = DateTimeToString(Now())
			sDescription = ""
			sAuthor = sPseudo
			iCategory = 1
			iVersion = 1
			bValid = False
		End If
	
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
		Response.Write "     {" & vbCRLF
		Response.Write "       document.edition.submit();" & vbCRLF
		Response.Write "     }" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		CreateTopTable "EditArticles", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""arID"" value=""" & iID & """>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""arTitle"" value=""" & Server.HTMLEncode(sTitle) & """ maxlength=""100"" size=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""arAuthor"" value=""" & Server.HTMLEncode(sAuthor) & """ maxlength=""100"" size=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetDateDDMMYYYY(StringToDate(dDate)) & "<input type=""hidden"" name=""arDate"" value=""" & dDate & """></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""arDescription"" cols=""50"" rows=""8"" class=""cell"">" & Server.HTMLEncode(sDescription) & "</textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		
		rSQL = "SELECT cID, cTitle FROM categories WHERE cType=" & CATEGORY_TYPE_ARTICLES& " ORDER BY cTitle"
		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Then
			Response.Write "      <select name=""arCategory"" class=""cell"">" & vbCRLF
			While Not oRs.EOF
				Response.Write "        <option value=""" & oRs("cID") & """"
				If oRs("cID") = iCategory Then Response.Write " selected"
				Response.Write ">" & Server.HTMLEncode(oRs("cTitle")) & "</option>" & vbCRLF
				oRs.MoveNext
			WEnd
			Response.Write "      </select>" & vbCRLF
			Response.Write "      " & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_CATEGORY") & " : <input name=""arCategory2"" class=""cell"" size=""20"" maxlength=""50"" value="""">" & vbCRLF
		Else
			Response.Write "      <input name=""arCategory2"" class=""cell"" size=""20"" maxlength=""50"" value=""" & Server.HTMLEncode(GLOBAL_SITE_NAME) & """>" & vbCRLF
		End If

		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""arVersion"" class=""cell"">" & vbCRLF
		
		rSQL = "SELECT vID, vCode FROM Versions ORDER BY vCode"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		While Not oRs.EOF
			Response.Write "        <option value=""" & oRs("vID") & """"
			If iVersion = oRs("vID") Then Response.Write " selected"
			Response.Write ">" & oRs("vCode") & "</option>" & vbCRLF
			oRs.MoveNext
		WEnd
		
		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
		Response.Write "    <td><input type=""checkbox"" name=""arValid"""
		If bValid Then Response.Write " checked"
		Response.Write "></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""confirmDo();""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		If sDo = "updt" Then
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td colspan=""2""><a href=""" & GLOBAL_SITE_ARTICLES_PAGES_PAGE & "?article=" & iID & """>" & GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_ARTICLE_PAGES") & "</a></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
		End If
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display deleting's form (to confirm)
	' IN  : iID (int) : article's id (table articles, field arID)
	' OUT : -
	Sub ConfirmDeleteArticle(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT arTitle, arDate, arAuthor, arDescription FROM articles WHERE arID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delArticle()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "ConfirmDelete", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""arID"" value=""" & iID & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td>" & CodeMessage(oRs("arTitle"), True) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
				Response.Write "    <td>" & GetDateDDMMYYYY(StringToDate(oRs("arDate"))) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("arAuthor")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
				Response.Write "    <td>" & oRs("arDescription") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=""button"" onClick=""delArticle();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=""button"" onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add an article's category (insert query)
	' IN  : sTitle (string) : category's title (table categories, field cTitle)
	' OUT : (int) : Category's id (table categories, fields cID)
	Function AddCategoryArticle(sTitle)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "SELECT TOP 1 cID FROM categories WHERE cParent=0 AND cTitle='" & SQLEncrypt(sTitle) & "' AND cDescription='" & SQLEncrypt(sTitle) & "' AND cType=" & CATEGORY_TYPE_ARTICLES & " ORDER BY cID DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		If oRs.EOF Then
			rSQL = "INSERT INTO categories (cParent, cTitle, cDescription, cImage, cType) VALUES (0, '" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sTitle) &"', '', " & CATEGORY_TYPE_ARTICLES & ")"
			DBExecute oCn, rSQL
			rSQL = "SELECT TOP 1 cID FROM categories WHERE cParent=0 AND cTitle='" & SQLEncrypt(sTitle) & "' AND cDescription='" & SQLEncrypt(sTitle) & "' AND cType=" & CATEGORY_TYPE_ARTICLES & " ORDER BY cID DESC"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				AddCategoryArticle = oRs(0)
			Else
				AddCategoryArticle = -1
			End If
		Else
			AddCategoryArticle = oRs(0)
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function

	' Add article (insert query)
	' IN  : sTitle (string) : article's title (table articles, field arTitle)
	'     : sDate (string) : article add date (table articles, field arDate)
	'     : sAuthor (string) : article's author (table articles, field arAuthor)
	'     : sDescription (string) : article's description (table articles, field arDescription)
	'     : iCategory (int) : article's category (table articles, field arCategory)
	'     : iVersion (int) : article's version language (table articles, field arVersion)
	'     : bValid (boolean) : article's validation (table articles, field arValid)
	' OUT : (boolean) : True if added
	Function AddArticle(sTitle, sAuthor, sDate, sDescription, iCategory, iVersion, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "INSERT INTO articles (arTitle, arDate, arAuthor, arDescription, arCategory, arVersion, arValid) VALUES ('" & SQLEncrypt(sTitle) & "', '" & sDate & "', '" & SQLEncrypt(sAuthor) & "', '" & SQLEncrypt(sDescription) & "', " & iCategory & ", " & iVersion & ", " & bValid & ")"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing
		AddArticle = True
	End Function

	' Modify article (update query)
	' IN  : iID (int) : article's id (table articles, field arID)
	'     : sTitle (string) : article's title (table articles, field arTitle)
	'     : sDate (string) : article add date (table articles, field arDate)
	'     : sAuthor (string) : article's author (table articles, field arAuthor)
	'     : sDescription (string) : article's description (table articles, field arDescription)
	'     : iCategory (int) : article's category (table articles, field arCategory)
	'     : iVersion (int) : article's version language (table articles, field arVersion)
	'     : bValid (boolean) : article's validation (table articles, field arValid)
	' OUT : (boolean) : True if modified
	Function ModifyArticle(iId, sTitle, sAuthor, sDate, sDescription, iCategory, iVersion, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE articles SET arTitle='" & SQLEncrypt(sTitle) & "', arDate='" & sDate & "', arDescription='" & SQLEncrypt(sDescription) & "', arCategory=" & iCategory & ", arVersion=" & iVersion & ", arValid=" & bValid & " WHERE arID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing
		ModifyArticle = True
	End Function

	' Delete article (delete query)
	' IN  : iID (int) : article's id (table articles, field arID)
	' OUT : (boolean) : True if deleted
	Function DeleteArticle(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "DELETE FROM articlespages WHERE apArticle=" & iID
		DBExecute oCn, rSQL
		rSQL = "DELETE FROM articles WHERE arID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing
		DeleteArticle = True
	End Function
	
	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminArticles()
		Dim bValid, iCategory
	
		Select Case Request("do") 
			Case "add"  : 
				If Request.Form("arCategory2") <> "" Then 
					iCategory = AddCategoryArticle(Request.Form("arCategory2"))
				Else
					iCategory = Request.Form("arCategory")
				End If
				If Request.Form("arValid") <> "" Then
					bValid = "1"
				Else
					bValid = "0"
				End If
				If AddArticle(Request.Form("arTitle"), Request.Form("arAuthor"), Request.Form("arDate"), Request.Form("arDescription"), iCategory, Request.Form("arVersion"), bValid) Then 
					sInfoPage = GetTranslation("LANG_ARTICLE") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_ARTICLE") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			Case "updt" : 
				If Request.Form("arCategory2") <> "" Then 
					iCategory = AddCategoryArticle(Request.Form("arCategory2"))
				Else
					iCategory = Request.Form("arCategory")
				End If
				If Request.Form("arValid") <> "" Then
					bValid = "1"
				Else
					bValid = "0"
				End If
				If ModifyArticle(Request.Form("arID"), Request.Form("arTitle"), Request.Form("arAuthor"), Request.Form("arDate"), Request.Form("arDescription"), iCategory, Request.Form("arVersion"), bValid) Then 
					sInfoPage = GetTranslation("LANG_ARTICLE") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_ARTICLE") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del"  :
				If DeleteArticle(Request.Form("arID")) Then 
					sInfoPage = GetTranslation("LANG_ARTICLE") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_ARTICLE") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub
	
	' Display articles admin page
	' IN  : -
	' OUT : -
	Sub DisplayAdminArticlesPage()
		Dim bDisplayTop, bAscSorted, sSortedField
		
		bDisplayTop = False
		bAscSorted = True
		sSortedField = ""
		
		sSortedField = Request.QueryString("sort")
		If sSortedField <> "" Then sSortedField = LCase(sSortedField)
		If Request.QueryString("sortype") = "desc" Then	bAscSorted = False

		Select Case Request("Do")
			Case "search" :	
				If Len(Request("name")) = 1 Then
					If Request("name") <> "0" Then
						DisplayAdminArticlesSearch Request("name") & "%"
					Else
						DisplayAdminArticlesSearch "[0-9]%"
					End If
				ElseIf Len(Request("name")) > 1 Then
					DisplayAdminArticlesSearch Request("name") & "%"
				End If
			Case "view" : DisplayAdminArticle Request("id")
			Case "new"  : EditArticle 0
			Case "edit" : EditArticle Request("id")
			Case "cdel" : ConfirmDeleteArticle Request("id")
			Case Else   : bDisplayTop = True
		End Select

		If bDisplayTop Then DisplayAdminTopArticles 10, sSortedField, bAscSorted
		DisplayAdminArticlesNavigation()
	End Sub
%>