<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display comment
	' IN  : iID (int) : comment's id (table comments, field cId)
	'     : iPage (int) : page's number
	' OUT : -
	Sub DisplayComment(iID, iPage)
		Dim oCn, oRs, oRs2, rSQL, iLine
		Dim sTitle, sAuthor, iType, sType, iRate, iItem, sCommentDate, sCommentText, sCommentIP, bValid

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT cAuthor, cDate, cRate, cItem, cType, cText, cIP, cValid FROM Comments WHERE cID=" & iID

		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then
			If oRs("cAuthor") = "" Then 
				sAuthor = GetTranslation("LANG_ANONYM")
			Else
				sAuthor = Server.HTMLEncode(oRs("cAuthor"))
			End If
			sCommentDate = oRs("cDate")
			iRate = oRs("cRate")
			iItem = oRs("cItem")
			iType = oRs("cType")
			sCommentText = oRs("cText")
			sCommentIP = oRs("cIP")
			If sCommentIP = "" Then sCommentIP = "-"
			bValid = oRs("cValid").Value
			sTitle = "-"

			Select Case iType
				Case CATEGORY_TYPE_NEWS : 
					sType = GetTranslation("LANG_NEWS")
					rSQL = "SELECT nTitle FROM News WHERE nID=" & iItem
				Case CATEGORY_TYPE_DOWNLOADS :
					sType = GetTranslation("LANG_DOWNLOADS")
					rSQL = "SELECT dTitle FROM downloads WHERE dID=" & iItem
				Case CATEGORY_TYPE_DIRECTORY : 
					sType = GetTranslation("LANG_DIRECTORY")
					rSQL = "SELECT dTitle FROM directory WHERE dID=" & iItem
				Case CATEGORY_TYPE_IMAGES : 
					sType = GetTranslation("LANG_IMAGES")
					rSQL = "SELECT iTitle FROM images WHERE iID=" & iItem
				Case CATEGORY_TYPE_ARTICLES : 
					sType =  GetTranslation("LANG_ARTICLES")
					rSQL = "SELECT arTitle FROM articles WHERE arID=" & iItem
				Case Else : 
					sType = "-"
					rSQL = ""
			End Select

			If rSQL <> "" Then
				Set oRs = DBRecordSet(oCn, rSQL)
				If Not oRs.EOF Then	sTitle = oRs(0)
			End If

			CreateTopTable "Comments", GetTranslation("LANG_COMMENT")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""150"">" & GetTranslation("LANG_TYPE") & "</td>" & vbCRLF
			Response.Write "    <td>" & sType & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""150"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "    <td>" & CodeMessage(sTitle, True) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""150"">" & GetTranslation("LANG_RATING") & "</td>" & vbCRLF
			Response.Write "    <td><img src=""" & GLOBAL_SITE_IMAGES_PATH & "rate_" & iRate & ".gif"" border=""0""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td colspan=""2"">" & vbCRLF
			Response.Write "      <span class=""small"">" & Replace(Replace(GetTranslation("LANG_POST_DATE_BY"), "%1%", GetDateLitteralDDMMYYYYHHMMSS(StringToDate(sCommentDate))), "%2%", sAuthor) & " - " & GetTranslation("LANG_IP") & " : " & sCommentIP & "</span><br><br>" & vbCRLF
			Response.Write "      <blockquote>" & CodeMessage(sCommentText, False) & "</blockquote>" & vbCRLF
			Response.Write "    </td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF	
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""150"">" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
			Response.Write "    <td>" & bValid & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display the top last comments posted
	' IN  : iTop (int) : number of results wanted
	'     : sSortedField (string) : field sorted
	'     : bAscSort (boolean) : if true = ASC sort, else DESC
	'     : iPage (int) : page's number
	' OUT : -
	Sub DisplayTopComments(iTop, sSortedField, bAscSort, iPage)
		Dim oCn, oRs, oRs2, rSQL, iLine
		Dim sTitle, sAuthor, sSortDesc

		Set oCn = DBConnexion(DB_MAIN)

		Select Case LCase(sSortedField)
			Case "cauthor" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_AUTHOR")
			Case "cdate" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_DATE")
			Case Else :
				' default value
				sSortedField = "cDate"
				bAscSort = False
				sSortDesc = GetTranslation("LANG_DATE")
		End Select

		rSQL = "SELECT TOP " & iTop & " cID, cAuthor, cText, cType, cDate FROM Comments ORDER BY " & sSortedField
		
		If Not bAscSort Then 
			rSQL = rSQL & " DESC"
			sSortDesc = sSortDesc & " (DESC)"
		Else
			sSortDesc = sSortDesc & " (ASC)"
		End If

		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then
			CreateTopTable "Comments", GetTranslation("LANG_COMMENTS") & "&nbsp;|&nbsp;<span class=""small"">" & Replace(GetTranslation("LANG_SORT_BY"), "%1%", sSortDesc)  & "</span>"
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""100"" align=""center"">"
			SortMenu GetTranslation("LANG_AUTHOR"), "cAuthor", sSortedField, bAscSort
			Response.Write "</td>" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TEXT") & "</td>" & vbCRLF
			Response.Write "    <td width=""80"" align=""center"">"
			SortMenu GetTranslation("LANG_DATE"), "cDate", sSortedField, bAscSort
			Response.Write "</td>" & vbCRLF
			Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_TYPE") & "</td>" & vbCRLF
			Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				If oRs("cAuthor") = "" Then 
					sAuthor = GetTranslation("LANG_ANONYM")
				Else
					sAuthor = Server.HTMLEncode(oRs("cAuthor"))
				End If
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td width=""100"">" & sAuthor & "</td>" & vbCRLF
				Response.Write "    <td>" & CodeMessageEx(oRs("cText"), 40, False, True) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & GetDateDDMMYY(StringToDate(oRs("cDate"))) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" 
				Select Case oRs("cType")
					Case CATEGORY_TYPE_NEWS : Response.Write GetTranslation("LANG_NEWS")
					Case CATEGORY_TYPE_DOWNLOADS : Response.Write GetTranslation("LANG_DOWNLOADS")
					Case CATEGORY_TYPE_DIRECTORY : Response.Write GetTranslation("LANG_DIRECTORY")
					Case CATEGORY_TYPE_IMAGES : Response.Write GetTranslation("LANG_IMAGES")
					Case CATEGORY_TYPE_ARTICLES : Response.Write GetTranslation("LANG_ARTICLES")
					Case Else : Response.Write "-"
				End Select
				Response.Write "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & vbCRLF
				MenuAdmin(oRs("cID") & "&page=" & iPage)
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)	
				oRs.MoveNext
			WEnd
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display comments by page (max per page : GLOBAL_COMMENTS_PAGE)
	' IN  : iPage (int) : page wanted
	' OUT : -
	Sub DisplayPageComments(iPage)
		Dim oCn, oRs, oRs2, rSQL, rSQL2, iLine, X
		Dim sAuthor

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT TOP " & GLOBAL_COMMENTS_PAGE*iPage & " cID, cAuthor, cDate, cType, cText FROM comments ORDER BY cDate DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		oRs.PageSize = GLOBAL_COMMENTS_PAGE
		If oRs.RecordCount <> - 1 Then
			oRs.AbsolutePage = iPage
		Else
			For X = 1 To (iPage-1)*GLOBAL_COMMENTS_PAGE
				oRs.MoveNext
			Next
		End If

		If Not oRs.EOF Then
			CreateTopTable "Comments", GetTranslation("LANG_COMMENTS")
			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
			Response.Write "    <td width=""80"">" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_TEXT") & "</td>" & vbCRLF
			Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			Response.Write "    <td width=""120"" align=""center"">" & GetTranslation("LANG_TYPE") & "</td>" & vbCRLF
			Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF

			iLine = 1
			While Not oRs.EOF
				sAuthor = oRs("cAuthor")
				If sAuthor = "" Then 
					sAuthor = GetTranslation("LANG_ANONYM")
				Else
					sAuthor = Server.HTMLEncode(sAuthor)
				End If
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & sAuthor & "</td>" & vbCRLF
				Response.Write "    <td>" & CodeMessageEx(oRs("cText"), 40, False, True) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & GetDateDDMMYY(StringToDate(oRs("cDate"))) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" 
				Select Case oRs("cType")
					Case CATEGORY_TYPE_NEWS : Response.Write GetTranslation("LANG_NEWS")
					Case CATEGORY_TYPE_DOWNLOADS : Response.Write GetTranslation("LANG_DOWNLOADS")
					Case CATEGORY_TYPE_DIRECTORY : Response.Write GetTranslation("LANG_DIRECTORY")
					Case CATEGORY_TYPE_IMAGES : Response.Write GetTranslation("LANG_IMAGES")
					Case CATEGORY_TYPE_ARTICLES : Response.Write GetTranslation("LANG_ARTICLES")
					Case Else : Response.Write "-"
				End Select
				Response.Write "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & vbCRLF
				MenuAdmin(oRs("cID") & "&page=" & iPage)
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)	
				oRs.MoveNext
			WEnd
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub
	
	' Add or edit comment
	' IN  : iID (int) : comment's id (if iID is null or = 0 then add comment)
	'     : iPage (int) : page's number
	' OUT : -
	Sub EditComment(iID, iPage)
		Dim oCn, oRs, rSQL
		Dim sEditTitle, sDo, iItem, sTitle, iRate, dDate, iType, sType, sAuthor, sText, bValid, sCommentIP

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sDo = "updt"
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_COMMENT")
			rSQL = "SELECT cItem, cDate, cAuthor, cText, cRate, cType, cIP, cValid FROM comments WHERE cID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				iItem = oRs("cItem")
				dDate = StringToDate(oRs("cDate"))
				sAuthor = oRs("cAuthor")
				sText = oRs("cText")
				iRate = oRs("cRate")
				iType = oRs("cType")
				bValid = oRs("cValid").Value
				sCommentIP = oRs("cIP")
				If sCommentIP = "" Then sCommentIP = "-"
				sTitle = "-"

				Select Case iType
					Case CATEGORY_TYPE_NEWS : 
						sType = GetTranslation("LANG_NEWS")
						rSQL = "SELECT nTitle FROM News WHERE nID=" & iItem
					Case CATEGORY_TYPE_DOWNLOADS :
						sType = GetTranslation("LANG_DOWNLOADS")
						rSQL = "SELECT dTitle FROM downloads WHERE dID=" & iItem
					Case CATEGORY_TYPE_DIRECTORY : 
						sType = GetTranslation("LANG_DIRECTORY")
						rSQL = "SELECT dTitle FROM directory WHERE dID=" & iItem
					Case CATEGORY_TYPE_IMAGES : 
						sType = GetTranslation("LANG_IMAGES")
						rSQL = "SELECT iTitle FROM images WHERE iID=" & iItem
					Case CATEGORY_TYPE_ARTICLES : 
						sType =  GetTranslation("LANG_ARTICLES")
						rSQL = "SELECT arTitle FROM articles WHERE arID=" & iItem
					Case Else : 
						sType = "-"
						rSQL = ""
				End Select

				If rSQL <> "" Then
					Set oRs = DBRecordSet(oCn, rSQL)
					If Not oRs.EOF Then sTitle = oRs(0)
				End If
			End If
		Else
			sDo = "add"
			dDate = Now()
			sEditTitle = GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_COMMENT")
		End If
	
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
		Response.Write "     {" & vbCRLF
		Response.Write "       document.edition.submit();" & vbCRLF
		Response.Write "     }" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		CreateTopTable "Edit", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & "?page=" & iPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""cID"" value=""" & iID & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLf
		Response.Write "    <td width=""120"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td>" & CodeMessage(sTitle, False) & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_AUTHOR") & "</td>" & vbCRLF
		Response.Write "    <td><input type=""hidden"" name=""cAuthor"" value=""" & Server.HTMLEncode(sAuthor) & """>" & Server.HTMLEncode(sAuthor) & " <span class=""small"">(" & GetTranslation("LANG_IP") & " : " & sCommentIP & ")</span></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetDateDDMMYYHHMMSS(dDate) & "<input type=""hidden"" name=""cDate"" value=""" & DateTimeToString(dDate) & """></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TYPE") & "</td>" & vbCRLF
		Response.Write "    <td>" & sType & "<input type=""hidden"" name=""cType"" value=""" & iType & """></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_RATING") & "</td>" & vbCRLF
		Response.Write "    <td><img src=""" & GLOBAL_SITE_IMAGES_PATH & "rate_" & iRate & ".gif"" border=""0""><input type=""hidden"" name=""cRate"" value=""" & iRate & """></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TEXT") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""cText"" cols=""50"" rows=""10"" class=""cell"">" & Server.HTMLEncode(sText) & "</textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
		Response.Write "    <td><input type=""checkbox"" name=""cValid"""
		If bValid Then Response.Write " checked"
		Response.Write "></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value="" " & GetTranslation("LANG_SUBMIT") & " "" class=""button"" onClick=""confirmDo();""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Modify comment
	' IN  : iID (int) : comment's id (table comments, field cID)
	'     : sAuthor (string) : comment's author (table comments, field cAuthor)
	'     : sText (string) : comment's content (table comments, field cText)
	'     : iType (int) : comment's type (table comments, field cType)
	'     : iRate (int) : comment's rate (table comments, field cRate)
	'     : sText (string) : comment's content (table comments, field cText)
	'     : bValid (boolean) : comment's validation (table comments, field cValid)
	' OUT : (boolean) : True if modified
	Function ModifyComment(iID, sAuthor, iType, iRate, sText, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE Comments SET cAuthor = '" & SQLEncrypt(sAuthor) & "', cText = '" & SQLEncrypt(sText) & "', cType = " & iType & ", cRate = " & iRate & ", cValid=" & bValid & " WHERE cID=" & iID
		oCn.Execute rSQL

		oCn.Close
		Set oCn = Nothing
		
		ModifyComment = True
	End Function

	' Delete comment
	' IN  : iID (int) : comment's id (table comments, field cID)
	' OUT : (boolean) : True if deleted
	Function DeleteComment(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)			
		rSQL = "DELETE FROM Comments WHERE cID=" & iID
		oCn.Execute rSQL

		oCn.Close
		Set oCn = Nothing

		DeleteComment = True
	End Function
	
	' Display the deleting comment's form (to confirm)
	' IN  : iID (int) : comment's id (table comments, field cID)
	'     : iPage (int) : page's number
	' OUT : -
	Sub ConfirmDeleteComment(iID, iPage)
		Dim oCn, oRs, rSQL, sAuthor, sText, iType, sType, sTitle

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT cAuthor, cText, cType FROM Comments WHERE cID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sAuthor = oRs("cAuthor")
				sText = oRs("cText")
				iType = oRs("cType")
				
				Select Case iType
					Case CATEGORY_TYPE_NEWS : 
						sType = GetTranslation("LANG_NEWS")
						rSQL = "SELECT nTitle FROM News WHERE nID=" & iID
					Case CATEGORY_TYPE_DOWNLOADS :
						sType = GetTranslation("LANG_DOWNLOADS")
						rSQL = "SELECT dTitle FROM downloads WHERE dID=" & iID
					Case CATEGORY_TYPE_DIRECTORY : 
						sType = GetTranslation("LANG_DIRECTORY")
						rSQL = "SELECT dTitle FROM directory WHERE dID=" & iID
					Case CATEGORY_TYPE_IMAGES : 
						sType = GetTranslation("LANG_IMAGES")
						rSQL = "SELECT iTitle FROM images WHERE iID=" & iID
					Case CATEGORY_TYPE_ARTICLES : 
						sType =  GetTranslation("LANG_ARTICLES")
						rSQL = "SELECT arTitle FROM articles WHERE arID=" & iID
					Case Else : 
						sType = "-"
						rSQL = ""
				End Select
				
				If rSQL <> "" Then
					Set oRs = DBRecordSet(oCn, rSQL)
					If Not oRs.EOF Then sTitle = oRs(0)
				End If

				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function DeleteComment()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "DeleteComment", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & "?page=" & iPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""cID"" value=""" & iID & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td width=""120"">" & GetTranslation("LANG_TYPE") & "</td><td>" & Server.HTMLEncode(sType) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td><td>" & CodeMessage(sTitle, True) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_AUTHOR") & "</td><td>" & Server.HTMLEncode(sAuthor) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TEXT") & "</td><td>" & CodeMessage(sText, True) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=button onClick=""DeleteComment();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=button onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display a navigation's bar
	' IN  : iCurrentPage (int) : current page
	' OUT : -
	Sub DisplayCommentsNavigation(iCurrentPage)
		Dim oCn, oRs, rSQL, rSQL2, iNum, iFound, iNbPages, X
		
		Set oCn = DBConnexion(DB_MAIN)
		
		rSQL = "SELECT Count(*) FROM Comments"
		Set oRs = DBRecordSet(oCn, rSQL)
		iNum = oRs(0)

		If iCurrentPage > 1 Then rSQL2 = " WHERE cID NOT IN (SELECT TOP " & (iCurrentPage-1)*GLOBAL_COMMENTS_PAGE & " c2.cID FROM Comments c2 ORDER BY c2.cDate DESC)"
		rSQL = "SELECT Count(cID) FROM Comments " & rSQL2
		Set oRs = DBRecordSet(oCn, rSQL)
		iFound = oRs(0)
		If iFound > GLOBAL_COMMENTS_PAGE Then iFound = GLOBAL_COMMENTS_PAGE

		oCn.Close
		Set oRs = Nothing
		Set oCn = Nothing

		CreateTopTable "CommentsNavigate", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_COMMENT")
		iNbPages = iNum\GLOBAL_COMMENTS_PAGE
		If iNum mod GLOBAL_COMMENTS_PAGE <> 0 Then iNbPages = iNbPages + 1
		If iNbPages > 1 Then
			If iCurrentPage > 1 Then Response.Write "      &nbsp;<a href=""" & sURLPage & "?page=" & iCurrentPage-1 & """>&lt;&lt;</a>" & vbCRLF
			For X = 1 To iNbPages
				If X <> iCurrentPage Then 
					Response.Write "      &nbsp;<a href=""" & sURLPage & "?page=" & X & """>" & X & "</a>" & vbCRLF
				Else
					Response.Write "&nbsp;<b>" & X & "</b>" & vbCRLF
				End If
			Next
			If iCurrentPage <> iNbPages Then Response.Write "      &nbsp;<a href=""" & sURLPage & "?page=" & iCurrentPage+1 & """>&gt;&gt;</a>" & vbCRLF
		End If
		Response.Write "<div align=""center"" class=""small"">" & Replace(Replace(GetTranslation("LANG_SEARCH_TOTAL"), "%1%", iFound), "%2%", iNum) & "</div>" & vbCRLF
		CreateBottomTable ""
	End Sub

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminComments()
		Dim bValid
	
		Select Case Request("do") 
			Case "updt" : 
				If Request.Form("cValid") <> "" Then
					bValid = "1"
				Else
					bValid = "0"
				End If
				If ModifyComment(Request.Form("cID"), Request.Form("cAuthor"), Request.Form("cType"), Request.Form("cRate"), Request.Form("cText"), bValid) Then 
					sInfoPage = GetTranslation("LANG_COMMENT") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_COMMENT") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del"  :
				If DeleteComment(Request.Form("cID")) Then 
					sInfoPage = GetTranslation("LANG_COMMENT") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_COMMENT") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub

	' Display page
	' IN  : -
	' OUT : -
	Sub DisplayAdminCommentsPage()
		Dim iPage

		iPage = Request.QueryString("page")
		If iPage <> "" And IsNumeric(iPage) Then 
			iPage = CInt(iPage)
			If iPage <= 0 Then iPage = 1
		Else
			iPage = 1
		End If

		Select Case Request("do")
			Case "view" : 
				DisplayComment Request("id"), iPage
			Case "edit" : 
				EditComment Request("id"), iPage
			Case "cdel" : 
				ConfirmDeleteComment Request("id"), iPage
		End Select
		
		DisplayPageComments iPage
		DisplayCommentsNavigation iPage
	End Sub
%>