<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display the last downloads (by Date)
	' IN  : iTop (int) : number of results wanted
	'     : sSortedField (string) : field sorted
	'     : bAscSort (boolean) : if true = ASC sort, else DESC
	' OUT : -
	Sub DisplayAdminTopDownloads(iTop, sSortedField, bAscSort)
		Dim oCn, oRs, rSQL, iLine, sSortDesc

		Set oCn = DBConnexion(DB_MAIN)

		Select Case LCase(sSortedField)
			Case "dtitle" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_TITLE")
			Case "dhits" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_HITS")
			Case "ddate" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_DATE")
			Case Else :
				' default value
				sSortedField = "dDate"
				bAscSort = False
				sSortDesc = GetTranslation("LANG_DATE")
		End Select

		If iTop <> "" and iTop <> 0 Then
			rSQL = "SELECT TOP " & iTop & " dId, dTitle, dDate, dHits FROM downloads ORDER BY " & sSortedField
		Else
			rSQL = "SELECT dId, dTitle, dDate, dHits FROM downloads ORDER BY " & sSortedField
		End If

		If Not bAscSort Then
			rSQL = rSQL & " DESC"
			sSortDesc = sSortDesc & " (DESC)"
		Else
			sSortDesc = sSortDesc & " (ASC)"
		End If

		Set oRs = DBRecordSet(oCn, rSQL)

		CreateTopTable "TopDownloads", GetTranslation("LANG_TOP") & " " & iTop & " - " & GetTranslation("LANG_DOWNLOADS") & "&nbsp;|&nbsp;<span class=""small"">" & Replace(GetTranslation("LANG_SORT_BY"), "%1%", sSortDesc)  & "</span>"
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>"
		SortMenu GetTranslation("LANG_TITLE"), "dTitle", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">"
		SortMenu GetTranslation("LANG_DATE"), "dDate", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">"
		SortMenu GetTranslation("LANG_HITS"), "dHits", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		If Not oRs.EOF Then
			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("dTitle")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & GetDateDDMMYY(StringToDate(oRs("dDate"))) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & oRs("dHits") & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & vbCRLF
				MenuAdmin(oRs("dID"))
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = 1 + ((iLine-1) XOR 1)
				oRs.MoveNext
			WEnd
		End If
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""4""><a href=""" & sURLPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_DOWNLOAD") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing		
	End Sub

	' Display information for a specific download
	' IN  : iID (int) : download's id (table downloads, field dID)
	' OUT : -
	Sub DisplayAdminDownload(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT dID, dTitle, dDescription, dDate, dHits, dSize, dURL, cTitle FROM downloads, categories WHERE dCategory=cID AND dID=" & iID

		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then
			CreateTopTable "Download", GetTranslation("LANG_DOWNLOAD")

			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "	<td>" & Server.HTMLEncode(oRs("dTitle")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
			Response.Write "	<td>" & Server.HTMLEncode(oRs("dDescription")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			Response.Write "	<td>" & GetDateDDMMYYYY(StringToDate(oRs("dDate"))) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
			Response.Write "	<td>" & oRs("dHits") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_SIZE") & "</td>" & vbCRLF
			Response.Write "	<td>"
			If oRs("dSize") < 1024 Then
				Response.Write oRs("dSize")  & " Ko"
			Else
				Response.Write Round(oRs("dSize")/1024, 1)  & " Mo"
			End If
			Response.Write "	</td>"
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("cTitle")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
			Response.Write "	<td><a href=""" & Server.HTMLEncode(oRs("dURL")) & """ target=""_blank"">" & Server.HTMLEncode(oRs("dURL")) & "</a></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
		
			CreateBottomTable ""
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display search's result on downloads
	' IN  : sQuery (string) : query data
	' OUT : -
	Sub DisplayAdminDownloadsSearch(sQuery)
		Dim oCn, oRs, rSQL, iLine, iNum

		iNum = 0

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT dId, dTitle, dDate, dHits FROM downloads WHERE dTitle LIKE '" & SQLEncrypt(sQuery) & "'"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "SearchDownloads", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_DOWNLOADS") & " (" & Server.HTMLEncode(Replace(sQuery, "%", "")) & ")"

		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF

		If Not oRs.EOF Then
			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("dTitle")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & GetDateDDMMYYYY(StringToDate(oRs("dDate"))) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & oRs("dHits") & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" 
				MenuAdmin(oRs("dID"))
				Response.Write "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				iNum = iNum + 1
				oRs.MoveNext
			WEnd
		End If

		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""4"">" & GetTranslation("LANG_DOWNLOADS_TOTAL") & " : " & iNum & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""4""><a href=""" & sURLPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_DOWNLOAD") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF

		CreateBottomTable ""
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display a navigation bar for downloads
	' IN  : -
	' OUT : -
	Sub DisplayAdminDownloadsNavigation()
		Dim X
		
		CreateTopTable "SearchDownloads", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_DOWNLOADS")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <form name=""Search"" method=""get"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "    <input type=""hidden"" name=""Do"" value=""search"">" & vbCRLF
		Response.Write "    <td><a href=""" & sURLPage & """>" & GetTranslation("LANG_TOP") & "</a>" & vbCRLF
		For X = 0 to 25
			Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=" & Chr(Asc("a")+X) & """>" & Chr(Asc("a")+X) & "</a>" & vbCRLF
		Next
		Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=0"">0-9</a>" & vbCRLF
		Response.Write "    &nbsp;<input name=""name"" size=""10"" maxlength=""20"" class=""cell"" onEnter=""javascript:document.search.submit()""></td>"
		Response.Write "    </form>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
	End Sub

	' Display edit download's form (add or update data)
	' IN  : iID (int) : download's id (table downloads, field dID), if null or = 0 then add downloads
	' OUT : -
	Sub EditDownload(iID)
		Dim oCn, oRs, rSQL
		Dim sEditTitle, sDo, sTitle, dDate, sDescription, sURL, iSize, iHits, iCategory, iVersion, bValid

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sDo = "updt"
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_DOWNLOAD")
			rSQL = "SELECT * FROM downloads WHERE dID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sTitle = oRs("dTitle")
				dDate = oRs("dDate")
				sDescription = oRs("dDescription")
				sURL = oRs("dURL")
				iSize = oRs("dSize")
				iHits = oRs("dHits")
				iCategory = oRs("dCategory")
				iVersion = oRs("dVersion")
				bValid = oRs.Fields("dValid").Value
			End If
		Else
			sDo = "add"
			sEditTitle = GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_DOWNLOAD")
			dDate = DateTimeToString(Now())
			sURL = "http://"
			iSize = 0
			iHits = 0
			iVersion = 1
			bValid = True
		End If
	
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
		Response.Write "     {" & vbCRLF
		Response.Write "       document.edition.submit();" & vbCRLF
		Response.Write "     }" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		CreateTopTable "EditDownloads", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""dID"" value=""" & iID & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td width=""150"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""dTitle"" value=""" & Server.HTMLEncode(sTitle) & """ maxlength=""100"" size=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetDateDDMMYYYY(StringToDate(dDate)) & "<input type=""hidden"" name=""dDate"" value=""" & dDate & """></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""dDescription"" cols=""50"" rows=""8"" class=""cell"">" & Server.HTMLEncode(sDescription) & "</textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""dURL"" value=""" & Server.HTMLEncode(sURL) & """ maxlength=""250"" size=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_SIZE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""dSize"" value=""" & iSize & """ maxlength=""10"" size=""10"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""dHits"" value=""" & iHits & """ maxlength=""10"" size=""10"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		
		rSQL = "SELECT cID, cTitle FROM categories WHERE cType=" & CATEGORY_TYPE_DOWNLOADS & " ORDER BY cTitle"
		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Then
			Response.Write "      <select name=""dCategory"" class=""cell"">" & vbCRLF
			While Not oRs.EOF
				Response.Write "        <option value=""" & oRs("cID") & """"
				If oRs("cID") = iCategory Then Response.Write " selected"
				Response.Write ">" & Server.HTMLEncode(oRs("cTitle")) & "</option>" & vbCRLF
				oRs.MoveNext
			WEnd
			Response.Write "      </select>" & vbCRLF
			Response.Write "      " & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_CATEGORY") & " : <input name=""dCategory2"" class=""cell"" size=""20"" maxlength=""50"" value="""">" & vbCRLF
		Else
			Response.Write "      <input name=""dCategory2"" class=""cell"" size=""20"" maxlength=""50"" value=""" & Server.HTMLEncode(GLOBAL_SITE_NAME) & """>" & vbCRLF
		End If

		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""dVersion"" class=""cell"">" & vbCRLF
		
		rSQL = "SELECT vID, vCode FROM Versions ORDER BY vCode"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		While Not oRs.EOF
			Response.Write "        <option value=""" & oRs("vID") & """"
			If iVersion = oRs("vID") Then Response.Write " selected"
			Response.Write ">" & oRs("vCode") & "</option>" & vbCRLF
			oRs.MoveNext
		WEnd
		
		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
		Response.Write "    <td><input type=""checkbox"" name=""dValid"""
		If bValid Then Response.Write " checked"
		Response.Write "></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""confirmDo();""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display deleting's form (to confirm)
	' IN  : iID (int) : download's id (table downloads, field dID)
	' OUT : -
	Sub ConfirmDeleteDownload(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT * FROM downloads WHERE dID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"">" & vbCRLF
				Response.Write "  function delDownload()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "ConfirmDelete", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""dID"" value=""" & iID & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("dTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
				Response.Write "    <td>" & GetDateDDMMYYYY(StringToDate(oRs("dDate"))) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_URL") & "</td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("dURL")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
				Response.Write "    <td>" & oRs("dHits") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=""2"" align=""right"">" & vbCRLF
				Response.Write "      <input type=""button"" name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=""button"" onClick=""delDownload();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=""button"" name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=""button"" onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add a download's category (insert query)
	' IN  : sTitle (string) : category's title (table categories, field cTitle)
	' OUT : (int) : Category's id (table categories, fields cID)
	Function AddCategoryDownload(sTitle)
		Dim oCn, oRs, rSQL
		Set oCn = Server.CreateObject("ADODB.Connection")
		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "SELECT TOP 1 cID FROM categories WHERE cParent=0 AND cTitle='" & SQLEncrypt(sTitle) & "' AND cDescription='" & SQLEncrypt(sTitle) & "' AND cType=" & CATEGORY_TYPE_DOWNLOADS & " ORDER BY cID DESC"
		Set oRs = DBRecordSet(oCn, rSQL)
		If oRs.EOF Then
			rSQL = "INSERT INTO categories (cParent, cTitle, cDescription, cImage, cType) VALUES (0, '" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sTitle) &"', '', " & CATEGORY_TYPE_DOWNLOADS & ")"
			DBExecute oCn, rSQL
			rSQL = "SELECT TOP 1 cID FROM categories WHERE cParent=0 AND cTitle='" & SQLEncrypt(sTitle) & "' AND cDescription='" & SQLEncrypt(sTitle) & "' AND cType=" & CATEGORY_TYPE_DOWNLOADS & " ORDER BY cID DESC"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				AddCategoryDownload = oRs(0)
			Else
				AddCategoryDownload = -1
			End If
		Else
			AddCategoryDownload = oRs(0)
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function

	' Add download (insert query)
	' IN  : sTitle (string) : download's title (table downloads, field dTitle)
	'     : sDate (string) : download add date (table downloads, field dDate)
	'     : sDescription (string) : download's description (table downloads, field dDescription)
	'     : sURL (string) : download's url (table downloads, field dURL)
	'     : iHits (int) : download's hits (table downloads, field dHits)
	'     : iSize (int) : download's size in kilobytes (table downloads, field dSize)
	'     : iCategory (int) : download's category (table downloads, field dCategory)
	'     : iVersion (int) : download's version language (table downloads, field dVersion)
	'     : bValid (boolean) : download's validation (table downloads, field dValid)
	' OUT : (boolean) : True if added
	Function AddDownload(sTitle, sDate, sDescription, sURL, iHits, iSize, iCategory, iVersion, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "INSERT INTO downloads (dTitle, dDate, dDescription, dURL, dHits, dSize, dCategory, dVersion, dValid) VALUES ('" & SQLEncrypt(sTitle) & "', '" & sDate & "', '" & SQLEncrypt(sDescription) & "', '" & SQLEncrypt(sURL) & "', " & iHits & ", " & iSize & ", " & iCategory & ", " & iVersion & ", " & bValid & ")"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		AddDownload = True
	End Function

	' Modify download (update query)
	' IN  : iID (int) : download's id (table downloads, field dID)
	'     : sTitle (string) : download's title (table downloads, field dTitle)
	'     : sDate (string) : download add date (table downloads, field dDate)
	'     : sDescription (string) : download's description (table downloads, field dDescription)
	'     : sURL (string) : download's url (table downloads, field dURL)
	'     : iHits (int) : download's hits (table downloads, field dHits)
	'     : iSize (int) : download's size in kilobytes (table downloads, field dSize)
	'     : iCategory (int) : download's category (table downloads, field dCategory)
	'     : iVersion (int) : download's version language (table downloads, field dVersion)
	'     : bValid (boolean) : download's validation (table downloads, field dValid)
	' OUT : (boolean) : True if added
	Function ModifyDownload(iID, sTitle, sDate, sDescription, sURL, iHits, iSize, iCategory, iVersion, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE downloads SET dTitle='" & SQLEncrypt(sTitle) & "', dDate='" & sDate & "', dDescription='" & SQLEncrypt(sDescription) & "', dURL='" & SQLEncrypt(sURL) & "', dHits=" & iHits & ", dSize=" & iSize & ", dCategory=" & iCategory & ", dVersion=" & iVersion & ", dValid=" & bValid & " WHERE dID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		ModifyDownload = True
	End Function

	' Delete download (delete query)
	' IN  : iID (int) : download's id (table downloads, field aID)
	' OUT : (boolean) : True if deleted
	Function DeleteDownload(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "DELETE FROM downloads WHERE dID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		DeleteDownload = True
	End Function
	
	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminDownloads()
		Dim bValid, iHits, iSize, iCategory
	
		Select Case Request("do") 
			Case "add"  : 
				If Request.Form("dCategory2") <> "" Then 
					iCategory = AddCategoryDownload(Request.Form("dCategory2"))
				Else
					iCategory = Request.Form("dCategory")
				End If
				If Request.Form("dValid") = "on" Then
					bValid = "1"
				Else
					bValid = "0"
				End If
				If Not IsNumeric(Request.Form("dHits")) Then 
					iHits = 0
				Else
					iHits =CLng(Request.Form("dHits"))
				End If
				If Not IsNumeric(Request.Form("dSize")) Then 
					iSize = 0
				Else
					iSize = CLng(Request.Form("dSize"))
				End If
				If AddDownload(Request.Form("dTitle"), Request.Form("dDate"), Request.Form("dDescription"), Request.Form("dURL"), iHits, iSize, iCategory, Request.Form("dVersion"), bValid) Then 
					sInfoPage = GetTranslation("LANG_DOWNLOAD") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_DOWNLOAD") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			Case "updt" : 
				If Request.Form("dCategory2") <> "" Then 
					iCategory = AddCategoryDownload(Request.Form("dCategory2"))
				Else
					iCategory = Request.Form("dCategory")
				End If
				If Request.Form("dValid") <> "" Then
					bValid = "1"
				Else
					bValid = "0"
				End If
				If Not IsNumeric(Request.Form("dHits")) Then 
					iHits = 0
				Else
					iHits = CLng(Request.Form("dHits"))
				End If
				If Not IsNumeric(Request.Form("dSize")) Then 
					iSize = 0
				Else
					iSize = CLng(Request.Form("dSize"))
				End If
				If ModifyDownload(Request.Form("dID"), Request.Form("dTitle"), Request.Form("dDate"), Request.Form("dDescription"), Request.Form("dURL"), iHits, iSize, iCategory, Request.Form("dVersion"), bValid) Then 
					sInfoPage = GetTranslation("LANG_DOWNLOAD") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_DOWNLOAD") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del"  :
				If DeleteDownload(Request.Form("dID")) Then 
					sInfoPage = GetTranslation("LANG_DOWNLOAD") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_DOWNLOAD") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub
	
	' Display downloads admin page
	' IN  : -
	' OUT : -
	Sub DisplayAdminDownloadsPage()
		Dim bDisplayTop, bAscSorted, sSortedField
		
		bDisplayTop = False
		bAscSorted = True
		sSortedField = ""
		
		sSortedField = Request.QueryString("sort")
		If sSortedField <> "" Then sSortedField = LCase(sSortedField)
		If Request.QueryString("sortype") = "desc" Then	bAscSorted = False

		Select Case Request("Do")
			Case "search" :	
				If Len(Request("name")) = 1 Then
					If Request("name") <> "0" Then
						DisplayAdminDownloadsSearch Request("name") & "%"
					Else
						DisplayAdminDownloadsSearch "[0-9]%"
					End If
				ElseIf Len(Request("name")) > 1 Then
					DisplayAdminDownloadsSearch Request("name") & "%"
				End If
			Case "view" : DisplayAdminDownload Request("id")
			Case "new"  : EditDownload 0
			Case "edit" : EditDownload Request("id")
			Case "cdel" : ConfirmDeleteDownload Request("id")
			Case Else   : bDisplayTop = True
		End Select

		If bDisplayTop Then DisplayAdminTopDownloads GLOBAL_DOWNLOADS_TOP, sSortedField, bAscSorted
		DisplayAdminDownloadsNavigation()
	End Sub
%>