<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Display the last images (by Date)
	' IN  : iTop (int) : number of results wanted
	'     : sSortedField (string) : field sorted
	'     : bAscSort (boolean) : if true = ASC sort, else DESC
	' OUT : -
	Sub DisplayAdminTopImages(iTop, sSortedField, bAscSort)
		Dim oCn, oRs, rSQL, iLine, sSortDesc

		Set oCn = DBConnexion(DB_MAIN)

		Select Case LCase(sSortedField)
			Case "ititle" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_TITLE")
			Case "ihits" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_HITS")
			Case "idate" :
				sSortedField = sSortedField
				sSortDesc = GetTranslation("LANG_DATE")
			Case Else :
				' default value
				sSortedField = "iDate"
				bAscSort = False
				sSortDesc = GetTranslation("LANG_DATE")
		End Select

		If iTop <> "" and iTop <> 0 Then
			rSQL = "SELECT TOP " & iTop & " iID, iTitle, iHits, iDate FROM images ORDER BY " & sSortedField
		Else
			rSQL = "SELECT iID, iTitle, iHits, iDate FROM images ORDER BY " & sSortedField
		End If

		If Not bAscSort Then
			rSQL = rSQL & " DESC"
			sSortDesc = sSortDesc & " (DESC)"
		Else
			sSortDesc = sSortDesc & " (ASC)"
		End If

		Set oRs = DBRecordSet(oCn, rSQL)

		CreateTopTable "TopImages", GetTranslation("LANG_TOP") & " " & iTop & " - " & GetTranslation("LANG_IMAGES") & "&nbsp;|&nbsp;<span class=""small"">" & Replace(GetTranslation("LANG_SORT_BY"), "%1%", sSortDesc)  & "</span>"
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>"
		SortMenu GetTranslation("LANG_TITLE"), "iTitle", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">"
		SortMenu GetTranslation("LANG_HITS"), "iHits", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">"
		SortMenu GetTranslation("LANG_DATE"), "iDate", sSortedField, bAscSort
		Response.Write "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF

		If Not oRs.EOF Then
			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("iTitle")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & oRs("iHits") & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & GetDateDDMMYY(StringToDate(oRs("iDate"))) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & vbCRLF
				MenuAdmin(oRs("iID"))
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				
				iLine = 1 + ((iLine-1) XOR 1)
				oRs.MoveNext
			WEnd
		End If
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""4""><a href=""" & sURLPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_IMAGE") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing		
	End Sub

	' Display information for a specific image
	' IN  : iID (int) : image's id (table images, field iID)
	' OUT : -
	Sub DisplayAdminImage(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT iID, iTitle, iDescription, iDate, iSourceSmall, iSourceNormal, iHits, iValid, cTitle, vCode FROM images, categories, versions WHERE iCategory=cID AND iVersion=vID AND iID=" & iID

		Set oRs = DBRecordSet(oCn, rSQL)
		If Not oRs.EOF Then
			CreateTopTable "Images", GetTranslation("LANG_IMAGE")

			Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
			Response.Write "	<td>" & Server.HTMLEncode(oRs("iTitle")) & "</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td width=""100"">" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
			Response.Write "	<td>" & CodeMessage(oRs("iDescription"), False) & "</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
			Response.Write "	<td>" & GetDateDDMMYY(StringToDate(oRs("iDate"))) & "</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_URL") & " " & GetTranslation("LANG_THUMBNAIL") & "</td>" & vbCRLF
			Response.Write "	<td>" & Server.HTMLEncode(oRs("iSourceSmall")) & "</td>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_URL") & " " & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
			Response.Write "	<td>" & Server.HTMLEncode(oRs("iSourceNormal")) & "</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_PREVIEW") & "</td>" & vbCRLF
			Response.Write "	<td><img src=""" & Server.HTMLEncode(oRs("iSourceSmall")) & """ border=""0""></td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
			Response.Write "	<td>" & oRs("iHits") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
			Response.Write "    <td>" & Server.HTMLEncode(oRs("cTitle")) & "</td>" & vbCRLF
			Response.Write "   </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline1"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
			Response.Write "	<td>" & Server.HTMLEncode(oRs("vCode")) & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "  <tr class=""tableline2"">" & vbCRLF
			Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
			Response.Write "	<td>" & oRs("iValid") & "</td>" & vbCRLF
			Response.Write "  </tr>" & vbCRLF
			Response.Write "</table>" & vbCRLF
		
			CreateBottomTable ""
		End If
		
		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display search's result on images
	' IN  : sQuery (string) : query data
	' OUT : -
	Sub DisplayAdminImagesSearch(sQuery)
		Dim oCn, oRs, rSQL, iLine, iNum
		iNum = 0
		
		Set oCn = DBConnexion(DB_MAIN)

		rSQL = "SELECT iId, iTitle, iDate, iHits FROM images WHERE iTitle LIKE '" & SQLEncrypt(sQuery) & "'"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		CreateTopTable "SearchImages", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_IMAGES") & " (" & Server.HTMLEncode(Replace(sQuery, "%", "")) & ")"

		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
		Response.Write "    <td width=""80"" align=""center"">" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
		Response.Write "    <td width=""100"" align=""center"">" & GetTranslation("LANG_ACTIONS") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF

		If Not oRs.EOF Then
			iLine = 1
			While Not oRs.EOF
				Response.Write "  <tr class=""tableline" & iLine & """>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("iTitle")) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & oRs("iHits") & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" & GetDateDDMMYYYY(StringToDate(oRs("iDate"))) & "</td>" & vbCRLF
				Response.Write "    <td align=""center"">" 
				MenuAdmin(oRs("iID"))
				Response.Write "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF

				iLine = 1 + ((iLine-1) XOR 1)
				iNum = iNum + 1
				oRs.MoveNext
			WEnd
		End If

		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""4"">" & GetTranslation("LANG_IMAGES") & " : " & iNum & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""4""><a href=""" & sURLPage & "?do=new"">" & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_IMAGE") & "</a></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF

		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display a navigation bar for images
	' IN  : -
	' OUT : -
	Sub DisplayAdminImagesNavigation()
		Dim X
		
		CreateTopTable "SearchImages", GetTranslation("LANG_SEARCH") & " - " & GetTranslation("LANG_IMAGES")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <form name=""Search"" method=""get"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "    <input type=""hidden"" name=""Do"" value=""search"">" & vbCRLF
		Response.Write "    <td>"
		Response.Write "&nbsp;<a href=""" & sURLPage & """>" & GetTranslation("LANG_TOP") & "</a>" & vbCRLF
		For X = 0 to 25
			Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=" & Chr(Asc("a")+X) & """>" & Chr(Asc("a")+X) & "</a>" & vbCRLF
		Next
		Response.Write "&nbsp;<a href=""" & sURLPage & "?do=search&name=0"">0-9</a>" & vbCRLF
		Response.Write "    &nbsp;<input name=""name"" size=""10"" maxlength=""20"" class=""cell"" onEnter=""javascript:document.search.submit()""></td>"
		Response.Write "    </form>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
	End Sub

	' Display edit image's form (add or update data)
	' IN  : iID (int) : image's id (table images, field iID), if null or = 0 then add image
	' OUT : -
	Sub EditImage(iID)
		Dim oCn, oRs, rSQL
		Dim sEditTitle, sDo, sTitle, dDate, sDescription, sSourceSmall, sSourceNormal, iHits, iCategory, iVersion, bValid

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			sDo = "updt"
			sEditTitle = GetTranslation("LANG_EDIT") & " - " & GetTranslation("LANG_IMAGE")
			rSQL = "SELECT * FROM images WHERE iID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				sTitle = oRs("iTitle")
				dDate = oRs("iDate")
				sDescription = oRs("iDescription")
				sSourceSmall = oRs("iSourceSmall")
				sSourceNormal = oRs("iSourceNormal")
				iHits = oRs("iHits")
				iCategory = oRs("iCategory")
				iVersion = oRs("iVersion")
				bValid = oRs.Fields("iValid").Value
			End If
		Else
			sDo = "add"
			sEditTitle = GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_IMAGE")
			dDate = DateTimeToString(Now())
			sSourceSmall = "http://"
			sSourceNormal = "http://"
			iHits = 0
			iVersion = 1
			bValid = True
		End If
	
		Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
		Response.Write "  function confirmDo()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "     if (confirm('" & JSEncrypt(GetTranslation("LANG_CONFIRM")) & "'))" & vbCRLF
		Response.Write "     {" & vbCRLF
		Response.Write "       document.edition.submit();" & vbCRLF
		Response.Write "     }" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "  function openSmallPicture()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "	var sMyPicture = document.edition.iSourceSmall.value;" & vbCRLF
		Response.Write "    if (sMyPicture != '')"
		Response.Write "	{" & vbCRLF
		Response.Write "		window.open('" & GLOBAL_SITE_PATH & GLOBAL_SITE_VIEW_IMAGE_PAGE & "?img=' + sMyPicture, 'Picture', 'width=500,height=100,menubar=no,resizable=yes');" & vbCRLF
		Response.Write "	}" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "  function openNormalPicture()" & vbCRLF
		Response.Write "  {" & vbCRLF
		Response.Write "	var sMyPicture = document.edition.iSourceNormal.value;" & vbCRLF
		Response.Write "    if (sMyPicture != '')"
		Response.Write "	{" & vbCRLF
		Response.Write "		window.open('" & GLOBAL_SITE_PATH & GLOBAL_SITE_VIEW_IMAGE_PAGE & "?img=' + sMyPicture, 'Picture', 'width=500,height=100,menubar=no,resizable=yes');" & vbCRLF
		Response.Write "	}" & vbCRLF
		Response.Write "  }" & vbCRLF
		Response.Write "</script>" & vbCRLF
		CreateTopTable "Edit", sEditTitle
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""edition"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""" & sDo & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""iID"" value=""" & iID & """>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td width=""150"">" & GetTranslation("LANG_FIELD") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALUE") & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""iTitle"" value=""" & Server.HTMLEncode(sTitle) & """ maxlength=""50"" size=""50"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
		Response.Write "    <td>" & GetDateDDMMYYYY(StringToDate(dDate)) & "<input type=""hidden"" name=""iDate"" value=""" & dDate & """></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
		Response.Write "    <td><textarea name=""iDescription"" cols=""50"" rows=""3"" class=""cell"">" & Server.HTMLEncode(sDescription) & "</textarea></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_URL") & " " & GetTranslation("LANG_THUMBNAIL") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <input name=""iSourceSmall"" value=""" & Server.HTMLEncode(sSourceSmall) & """ maxlength=""250"" size=""50"" class=""cell"">" & vbCRLF
		Response.Write "      <a href=""javascript:openSmallPicture()""><img src=""" & GLOBAL_SITE_IMAGES_PATH & "view.gif"" border=""0""></a>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_URL") & " " & GetTranslation("LANG_IMAGE") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <input name=""iSourceNormal"" value=""" & Server.HTMLEncode(sSourceNormal) & """ maxlength=""250"" size=""50"" class=""cell"">" & vbCRLF
		Response.Write "      <a href=""javascript:openNormalPicture()""><img src=""" & GLOBAL_SITE_IMAGES_PATH & "view.gif"" border=""0""></a>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_HITS") & "</td>" & vbCRLF
		Response.Write "    <td><input name=""iHits"" value=""" & iHits & """ type=""hidden"">" & iHits & "</td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_CATEGORY") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		
		rSQL = "SELECT cID, cTitle FROM categories WHERE cType=" & CATEGORY_TYPE_IMAGES & " ORDER BY cTitle"
		Set oRs = DBRecordSet(oCn, rSQL)

		If Not oRs.EOF Then
			Response.Write "      <select name=""iCategory"" class=""cell"">" & vbCRLF
			While Not oRs.EOF
				Response.Write "        <option value=""" & oRs("cID") & """"
				If oRs("cID") = iCategory Then Response.Write " selected"
				Response.Write ">" & Server.HTMLEncode(oRs("cTitle")) & "</option>" & vbCRLF
				oRs.MoveNext
			WEnd
			Response.Write "      </select>" & vbCRLF
			Response.Write "      " & GetTranslation("LANG_ADD") & " - " & GetTranslation("LANG_CATEGORY") & " : <input name=""iCategory2"" class=""cell"" size=""20"" maxlength=""50"" value="""">" & vbCRLF
		Else
			Response.Write "      <input name=""iCategory2"" class=""cell"" size=""20"" maxlength=""50"" value=""" & Server.HTMLEncode(GLOBAL_SITE_NAME) & """>" & vbCRLF
		End If

		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VERSION") & "</td>" & vbCRLF
		Response.Write "    <td>" & vbCRLF
		Response.Write "      <select name=""iVersion"" class=""cell"">" & vbCRLF
		
		rSQL = "SELECT vID, vCode FROM Versions ORDER BY vCode"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		While Not oRs.EOF
			Response.Write "        <option value=""" & oRs("vID") & """"
			If iVersion = oRs("vID") Then Response.Write " selected"
			Response.Write ">" & oRs("vCode") & "</option>" & vbCRLF
			oRs.MoveNext
		WEnd

		Response.Write "      </select>" & vbCRLF
		Response.Write "    </td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_VALID") & "</td>" & vbCRLF
		Response.Write "    <td><input type=""checkbox"" name=""iValid"""
		If bValid Then Response.Write " checked"
		Response.Write "></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2""><input type=""button"" value=""" & GetTranslation("LANG_SUBMIT") & """ class=""button"" onClick=""confirmDo();""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Display deleting's form (to confirm)
	' IN  : iID (int) : image's id (table images, field iID)
	' OUT : -
	Sub ConfirmDeleteImage(iID)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)

		If iID <> "" and iID <> 0 Then
			rSQL = "SELECT iTitle, iDescription, iDate FROM images WHERE iID=" & iID
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "  function delImage()" & vbCRLF
				Response.Write "  {" & vbCRLF
				Response.Write "    document.suppression.Do.value='del';" & vbCRLF
				Response.Write "    document.suppression.submit();" & vbCRLF
				Response.Write "  }" & vbCRLF
				Response.Write "</script>" & vbCRLF
				CreateTopTable "ConfirmDelete", GetTranslation("LANG_CONFIRM") & " - " & GetTranslation("LANG_DELETE")
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "<form name=""suppression"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""iID"" value=""" & iID & """>" & vbCRLF
				Response.Write "<input type=""hidden"" name=""Do"" value="""">" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_CONFIRM_DELETE") & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_TITLE") & "</td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("iTitle")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline2"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DESCRIPTION") & "</td>" & vbCRLF
				Response.Write "    <td>" & Server.HTMLEncode(oRs("iDescription")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tableline1"">" & vbCRLF
				Response.Write "    <td>" & GetTranslation("LANG_DATE") & "</td>" & vbCRLF
				Response.Write "    <td>" & StringToDate(oRs("iDate")) & "</td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
				Response.Write "    <td colspan=2 align=right>" & vbCRLF
				Response.Write "      <input type=button name=""Oui"" value=""" & GetTranslation("LANG_YES") & """ class=""button"" onClick=""delImage();"">&nbsp;&nbsp;&nbsp;&nbsp;" & vbCRLF
				Response.Write "      <input type=button name=""Non"" value=""" & GetTranslation("LANG_NO") & """ class=""button"" onClick=""javascript:document.suppression.submit();"">&nbsp;" & vbCRLF
				Response.Write "    </td>" & vbCRLF
				Response.Write "  </tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Sub

	' Add a image's category (insert query)
	' IN  : sTitle (string) : category's title (table categories, field cTitle)
	' OUT : (int) : Category's id (table categories, fields cID)
	Function AddCategoryImage(sTitle)
		Dim oCn, oRs, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "SELECT TOP 1 cID FROM categories WHERE cParent=0 AND cTitle='" & SQLEncrypt(sTitle) & "' AND cDescription='" & SQLEncrypt(sTitle) & "' AND cType=" & CATEGORY_TYPE_IMAGES & " ORDER BY cID DESC"
		Set oRs = DBRecordSet(oCn, rSQL)

		If oRs.EOF Then
			rSQL = "INSERT INTO categories (cParent, cTitle, cDescription, cImage, cType) VALUES (0, '" & SQLEncrypt(sTitle) & "', '" & SQLEncrypt(sTitle) &"', '', " & CATEGORY_TYPE_IMAGES & ")"
			DBExecute oCn, rSQL
			rSQL = "SELECT TOP 1 cID FROM categories WHERE cParent=0 AND cTitle='" & SQLEncrypt(sTitle) & "' AND cDescription='" & SQLEncrypt(sTitle) & "' AND cType=" & CATEGORY_TYPE_IMAGES & " ORDER BY cID DESC"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				AddCategoryImage = oRs(0)
			Else
				AddCategoryImage = -1
			End If
		Else
			AddCategoryImage = oRs(0)
		End If

		oCn.Close
		Set oCn = Nothing
	End Function

	' Add image (insert query)
	' IN  : sTitle (string) : image's title (table images, field iTitle)
	'     : sDate (string) : image add date (table images, field iDate)
	'     : sDescription (string) : image's description (table images, field iDescription)
	'     : sSourceSmall (string) : image's source for thumbnail (table images, field iSourceSmal)
	'     : sSourceNormal (string) : image's source (table images, field iSourceNormal)
	'     : iHits (int) : number of times where image has been viewed (table images, field iHits)
	'     : iCategory (int) : image's category (table images, field iCategory)
	'     : iVersion (int) : image's version language (table images, field iVersion)
	'     : bValid (boolean) : image's validation (table images, field iValid)
	' OUT : (boolean) : True if added
	Function AddImage(sTitle, sDate, sDescription, sSourceSmall, sSourceNormal, iHits, iCategory, iVersion, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "INSERT INTO images (iTitle, iDate, iDescription, iSourceSmall, iSourceNormal, iHits, iCategory, iVersion, iValid) VALUES ('" & SQLEncrypt(sTitle) & "', '" & sDate & "', '" & SQLEncrypt(sDescription) & "', '" & SQLEncrypt(sSourceSmall) & "', '" & SQLEncrypt(sSourceNormal) & "', " & iHits & ", " & iCategory & ", " & iVersion & ", " & bValid & ")"
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		AddImage = True
	End Function

	' Modify image (update query)
	' IN  : iID (int) : image's id (table images, field iID)
	'     : sTitle (string) : image's title (table images, field iTitle)
	'     : sDate (string) : image add date (table images, field iDate)
	'     : sDescription (string) : image's description (table images, field iDescription)
	'     : sSourceSmall (string) : image's source for thumbnail (table images, field iSourceSmal)
	'     : sSourceNormal (string) : image's source (table images, field iSourceNormal)
	'     : iHits (int) : number of times where image has been viewed (table images, field iHits)
	'     : iCategory (int) : image's category (table images, field iCategory)
	'     : iVersion (int) : image's version language (table images, field iVersion)
	'     : bValid (boolean) : image's validation (table images, field iValid)
	' OUT : (boolean) : True if added
	Function ModifyImage(iID, sTitle, sDate, sDescription, sSourceSmall, sSourceNormal, iHits, iCategory, iVersion, bValid)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "UPDATE images SET iTitle='" & SQLEncrypt(sTitle) & "', iDate='" & sDate & "', iDescription='" & SQLEncrypt(sDescription) & "', iSourceSmall='" & SQLEncrypt(sSourceSmall) & "', iSourceNormal='" & SQLEncrypt(sSourceNormal) & "', iHits=" & iHits & ", iCategory=" & iCategory & ", iVersion=" & iVersion & ", iValid=" & bValid & " WHERE iID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		ModifyImage = True
	End Function

	' Delete image (delete query)
	' IN  : iID (int) : image's id (table images, field iID)
	' OUT : (boolean) : True if deleted
	Function DeleteImage(iID)
		Dim oCn, rSQL

		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "DELETE FROM images WHERE iID=" & iID
		DBExecute oCn, rSQL

		oCn.Close
		Set oCn = Nothing

		DeleteImage = True
	End Function
	
	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAdminImages()
		Dim bValid, iCategory
	
		Select Case Request("do") 
			Case "add"  : 
				If Request.Form("iCategory2") <> "" Then 
					iCategory = AddCategoryImage(Request.Form("iCategory2"))
				Else
					iCategory = Request.Form("iCategory")
				End If
				If Request.Form("iValid") <> "" Then
					bValid = "1"
				Else
					bValid = "0"
				End If
				If AddImage(Request.Form("iTitle"), Request.Form("iDate"), Request.Form("iDescription"), Request.Form("iSourceSmall"), Request.Form("iSourceNormal"), Request.Form("iHits"), iCategory, Request.Form("iVersion"), bValid) Then 
					sInfoPage = GetTranslation("LANG_IMAGE") & " - " & GetTranslation("LANG_ADD_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_IMAGE") & " - " & GetTranslation("LANG_ADD_ERROR")
				End If
			Case "updt" : 
				If Request.Form("iCategory2") <> "" Then 
					iCategory = AddCategoryImage(Request.Form("iCategory2"))
				Else
					iCategory = Request.Form("iCategory")
				End If
				If Request.Form("iValid") <> "" Then
					bValid = "1"
				Else
					bValid = "0"
				End If
				If ModifyImage(Request.Form("iID"), Request.Form("iTitle"), Request.Form("iDate"), Request.Form("iDescription"), Request.Form("iSourceSmall"), Request.Form("iSourceNormal"), Request.Form("iHits"), iCategory, Request.Form("iVersion"), bValid) Then 
					sInfoPage = GetTranslation("LANG_IMAGE") & " - " & GetTranslation("LANG_MODIFY_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_IMAGE") & " - " & GetTranslation("LANG_MODIFY_ERROR")
				End If
			Case "del"  :
				If DeleteImage(Request.Form("iID")) Then 
					sInfoPage = GetTranslation("LANG_IMAGE") & " - " & GetTranslation("LANG_DELETE_SUCCESS")
				Else
					sInfoPage = GetTranslation("LANG_IMAGE") & " - " & GetTranslation("LANG_DELETE_ERROR")
				End If
		End Select
	End Sub
	
	' Display images admin page
	' IN  : -
	' OUT : -
	Sub DisplayAdminImagesPage()
		Dim bDisplayTop, sSortedField, bAscSorted
		
		bAscSorted = True
		sSortedField = ""
		
		sSortedField = Request.QueryString("sort")
		If sSortedField <> "" Then sSortedField = LCase(sSortedField)
		If Request.QueryString("sortype") = "desc" Then	bAscSorted = False

		bDisplayTop = False

		Select Case Request("Do")
			Case "search" :	
				If Len(Request("name")) = 1 Then
					If Request("name") <> "0" Then
						DisplayAdminImagesSearch Request("name") & "%"
					Else
						DisplayAdminImagesSearch "[0-9]%"
					End If
				ElseIf Len(Request("name")) > 1 Then
					DisplayAdminImagesSearch Request("name") & "%"
				End If
			Case "view" : DisplayAdminImage Request("id")
			Case "new"  : EditImage 0
			Case "edit" : EditImage Request("id")
			Case "cdel" : ConfirmDeleteImage Request("id")
			Case Else   : bDisplayTop = True
		End Select

		If bDisplayTop Then DisplayAdminTopImages 10, sSortedField, bAscSorted
		DisplayAdminImagesNavigation()
	End Sub
%>