<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Authenticate user in the members' section
	' IN  : sLogin (string) : user's login (table users, field uLogin)
	'       sMyPassword (string) : user's password (table users, field uPassword)
	'       bKeepalive (boolean) : if true, set cookie's expiration time to 1 year
	'       bRedirect (boolean) : if true, redirect to the Default.asp page
	'       sRedirectPage (string) : if bRedirect = true, then redirect to this page
	' OUT : (boolean) : True if authenticate successfully, False if not
	Function Authentication(ByRef sLogin, ByRef sMyPassword, ByVal bKeepalive, ByVal bRedirect, ByVal sRedirectPage)
		Dim oCn, oRs, rSQL, bDone
		Dim bValid, sUserLogin, sUserPassword, sUserEmail, iUserID
		
		bDone = False
		bValid = False

		rSQL = "SELECT uID, uLogin, uEmail, uPassword, uValid FROM users WHERE uLogin LIKE '" & SQLEncrypt(sLogin) & "'"
		
		Set oCn = DBConnexion(DB_MAIN)
		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then
			bValid = oRs("uValid").Value
			iUserID = oRs("uID")
			sUserLogin = oRs("uLogin")
			sUserEmail = oRs("uEmail")
			sUserPassword = oRs("uPassword")
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
		
		If bValid Then
			If sUserPassword = sMyPassword Then
				bDone = True
				Response.Cookies("pseudoid") = iUserID
				Response.Cookies("pseudo") = sUserLogin
				Response.Cookies("email") = sUserEmail
				sPseudo = sUserLogin

				If bKeepalive Then 
					Response.Cookies("pseudoid").Expires = Date + 365
					Response.Cookies("pseudo").Expires = Date + 365
					Response.Cookies("email").Expires = Date + 365
				End If
			Else
				sMyPassword = ""
			End If
		Else
			sLogin = ""
			sPseudo = ""
		End If
		
		Authentication = bDone

		If bDone Then
			If bRedirect Then
				If sRedirectPage = "" Then 
					sRedirectPage = "Default.asp?do=in"
				Else
					If InStr(sRedirectPage, "?") > 0 Then
						sRedirectPage = sRedirectPage & "&do=in"
					Else
						sRedirectPage = sRedirectPage & "?do=in"
					End If
				End If
				Set oLangXML = Nothing
				Response.Redirect GLOBAL_SITE_PATH & sRedirectPage
				Response.End
			End If
		End If
	End Function
	
	' Send password if lost
	' IN  : sMyEmail (string) : user's email address (table users, field sEmail)
	' OUT : (boolean) : True if account found and email sent, False if not
	Function SendPassword(sMyEmail)
		Dim oCn, oRs, rSQL
		
		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "SELECT uLogin, uPassword FROM users WHERE uEmail LIKE '" & SQLEncrypt(sMyEmail) & "'"
		Set oRs = DBRecordSet(oCn, rSQL)
		
		If Not oRs.EOF Then
			Dim sText
			
			sText = sText & "  " & GetTranslation("LANG_LOGIN") & " : " & oRs("uLogin") & vbCRLF
			sText = sText & "  " & GetTranslation("LANG_PASSWORD") & " : " & oRs("uPassword") & vbCRLF
			sText = sText & "  " & GetTranslation("LANG_EMAIL") & " : " & sMyEmail & vbCRLF
			sText = sText & vbCRLF & vbCRLF & GLOBAL_SITE_NAME & vbCRLF & vbCRLF
			sText = sText & GLOBAL_SITE_URL
			SendPassword = SendMail(GLOBAL_ACCOUNTS_EMAIL, sMyEmail, GetTranslation("LANG_LOST_PASSWORD"), sText, False)
		Else
			SendPassword = False
		End If

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function

	' Display authentication's page
	' IN  : -
	' OUT : -
	Sub DisplayAuthenticationPage()
		Dim sPreviousPage, iPos
		
		If Request.Form("urlpage") <> "" Then
			sPreviousPage = Request.Form("urlpage")
		Else
			sPreviousPage = Request.ServerVariables("HTTP_REFERER")
			iPos = InstrRev(sPreviousPage, "/")
			If iPos > 0 and iPos > 7 Then
				sPreviousPage = Mid(sPreviousPage, iPos+1)
			Else
				sPreviousPage = "Default.asp"
			End If
		End If

		CreateTopTable "Authentication", GetTranslation("LANG_AUTHENTICATION")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""Authentication"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""authent"">" & vbCRLF
		Response.Write "<input type=""hidden"" name=""urlpage"" value=""" & sPreviousPage & """>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_LOGIN") & "</td>" & vbCRLF
		Response.Write "      <td width=""150"" align=""right"">" & vbCRLF
		Response.Write "        <input name=""pseudo"" maxlength=""20"" size=""20"" value=""" & vbCRLF
		If Request.Form("pseudo") <> "" Then 
			Response.Write Server.HTMLEncode(Request.Form("pseudo"))
		Else
			Response.Write GetTranslation("LANG_LOGIN")
		End If
		Response.Write """ onFocus=""this.value='';"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline2"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_PASSWORD") & "</td>" & vbCRLF
		Response.Write "    <td align=""right""><input name=""mdp"" type=""password"" maxlength=""20"" size=""20"" onFocus=""this.value='';"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_MEMORIZE") & "</td>" & vbCRLF
		Response.Write "    <td align=""right""><input name=""memo"" type=""checkbox""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2"" align=""right""><input name=""bsubmit"" type=""submit"" value=""" & GetTranslation("LANG_VALIDATE") & """ class=""button""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</form>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
		
		CreateTopTable "ForgotPassword", GetTranslation("LANG_LOST_PASSWORD")
		Response.Write GLOBAL_SITE_SUBTABLE & vbCRLF
		Response.Write "<form name=""lostpassword"" method=""post"" action=""" & sUrlPage & """>" & vbCRLF
		Response.Write "<input type=""hidden"" name=""Do"" value=""getpassword"">" & vbCRLF
		Response.Write "  <tr class=""tableline1"">" & vbCRLF
		Response.Write "    <td>" & GetTranslation("LANG_EMAIL") & "</td>" & vbCRLF
		Response.Write "    <td align=""right""><input name=""email"" maxlength=""50"" size=""40"" class=""cell""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "  <tr class=""tablelinemain"">" & vbCRLF
		Response.Write "    <td colspan=""2"" align=""right""><input name=""bsubmit"" type=""submit"" value=""" & GetTranslation("LANG_VALIDATE") & """ class=""button""></td>" & vbCRLF
		Response.Write "  </tr>" & vbCRLF
		Response.Write "</table>" & vbCRLF
		CreateBottomTable ""
	End Sub

	' Process actions
	' IN  : -
	' OUT : -
	Sub DoAuthentication()
		Select Case Request.Form("Do")
			Case "authent" :
				If Request.Form("pseudo") <> "" and Request.Form("mdp") <> "" Then
					Dim sLogin, sMyPassword, bMemo
					sLogin = Request.Form("pseudo")
					sMyPassword = Request.Form("mdp")
					If Request.Form("memo") = "on" Then 
						bMemo = True
					Else
						bMemo = False
					End If

					Authentication sLogin, sMyPassword, bMemo, True, Request.Form("urlpage")

					If sLogin = "" Then
						sInfoPage = GetTranslation("LANG_LOGIN_UNKNOWN")
					ElseIf sMyPassword = "" Then
						sInfoPage = GetTranslation("LANG_BAD_PASSWORD")
					Else
						sInfoPage = GetTranslation("LANG_BAD_LOGIN")
					End If
				End If
			Case "getpassword" :
				If Request.Form("email") <> "" Then
					If SendPassword(Request.Form("email")) Then
						sInfoPage = GetTranslation("LANG_PASSWORD_SENT")
					Else
						sInfoPage = GetTranslation("LANG_BAD_EMAIL")
					End If
				End If
		End Select
	End Sub
%>