<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Create the top part of a standard table
	' IN  : sTabName (string) : table's name (can be empty)
	'     : sHeader (string) : title displayed
	' OUT : -
	Sub CreateTopTable(sTabName, sHeader)
		Response.Write "      <table id=""" & sTabName & """ width=""100%"" align=""center"" cellspacing=""0"" cellpadding=""0"" class=""myTable"">" & vbCRLF
		If sHeader <> "" Then
			Response.Write "		<tr>" & vbCRLF
			Response.Write "          <td class=""myTitle"" width=""100%"">" & sHeader & "</td>" & vbCRLF
			Response.Write "        </tr>" & vbCRLF
		End If
		Response.Write "        <tr>" & vbCRLF
		Response.Write "          <td width=""100%"" class=""myTD"">" & vbCRLF
	End Sub

	' Create the bottom part of a standard table
	' IN  : sFooter (string) : footer
	' OUT : -
	Sub CreateBottomTable(sFooter)
		Response.Write "		  </td>" & vbCRLF
		Response.Write "        </tr>" & vbCRLF
		If sFooter <> "" Then
			Response.Write "		<tr>" & vbCRLF
			Response.Write "          <td width=""100%"" align=""center"" class=""myTD""><br><span class=""small"">" & sFooter & "</span></td>" & vbCRLF
			Response.Write "        </tr>" & vbCRLF
		End If
		Response.Write "      </table>" & vbCRLF
		Response.Write "<br>" & vbCRLF
	End Sub

	' Create a standard table
	' IN  : sTabName (string) : table's name (can be empty)
	'     : sHeader (string) : title displayed
	'     : sText (string) : text in the table
	'     : sFooter (string) : footer
	' OUT : -
	Sub CreateTable(sTabName, sHeader, sText, sFooter)
		CreateTopTable sTabName, sHeader
		Response.Write sText & vbCRLF
		CreateBottomTable sFooter
	End Sub

	' Get number of anonymous visitors connected to the site
	' IN  : -
	' OUT : (int) number of anonymous visitors
	Function AnonymousVisitors()
		Dim oCn, oRs, rSQL
		
		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "SELECT Count(*) FROM sessions"
		Set oRs = DBRecordSet(oCn, rSQL)
		AnonymousVisitors = oRs(0)

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function
	
	' Get number of authenticated visitors connected to the site
	' IN  : -
	' OUT : (int) number of authenticated visitors
	Function AuthentVisitors()
		Dim oCn, oRs, rSQL
		
		Set oCn = DBConnexion(DB_MAIN)
		rSQL = "SELECT Count(*) FROM sessions WHERE sLogin<>''"
		Set oRs = DBRecordSet(oCn, rSQL)
		AuthentVisitors = oRs(0)

		oCn.Close
		Set oCn = Nothing
		Set oRs = Nothing
	End Function

	' Display number of visitors connected to the site
	' IN  : -
	' OUT : -
	Sub DisplayDynamicCounter()
		If bDisplayDynamicCount Then
			Dim iAuthent, iAnonymous

			iAnonymous = AnonymousVisitors
			iAuthent = AuthentVisitors
			CreateTopTable "NbVisitors", GetTranslation("LANG_VISITORS")
			Response.Write "<span class=""small"">" 
			Response.Write Replace(Replace(GetTranslation("LANG_CURRENT_VISITORS"), "%1%", iAnonymous), "%2%", iAuthent) & vbCRLF
			Response.Write "<br><a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_WHO_ONLINE_PAGE & """>" & GetTranslation("LANG_MORE_INFORMATION") & "</a>" & vbCRLF
			Response.Write "</span>" & vbCRLF
			CreateBottomTable ""
		End If
	End Sub

	' Display favorites websites
	' IN  : -
	' OUT : -
	Sub DisplayFavorites()
		If bDisplayFavorites Then
			Dim oCn, oRs, rSQL

			Set oCn = DBConnexion(DB_MAIN)
			rSQL = "SELECT uTitle, uURL, uHits FROM urls WHERE uFavorite=1 ORDER BY uHits DESC"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then
				CreateTopTable "MyFavorites", GetTranslation("LANG_MY_FAVORITES")
				Response.Write "<table id=""FavoritesTable"" border=""0"" cellspacing=""0"" cellpadding=""0"">" & vbCRLF
				While Not oRs.EOF
					Response.Write "  <tr>" & vbCRLF
					Response.Write "    <td class=""small""><a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_GOTOURL_PAGE & "?url=" & Server.URLEncode(oRs("uURL")) & """ target=""_blank"">" & Server.HTMLEncode(oRS("uTitle")) & "</a> (" & oRs("uHits") & ")</td>" & vbCRLF
					Response.Write "  </tr>" & vbCRLF
					oRs.MoveNext
				WEnd
				Response.Write "</table>" & vbCRLF
				CreateBottomTable ""
			End If
			
			oCn.Close()
			Set oCn = Nothing
			Set oRs = Nothing
		End If
	End Sub

	' Display search engine's form
	' IN  : -
	' OUT : -
	Sub DisplaySearch()
		Dim bSelected
		
		bSelected = True
		If bDisplaySearchEngine Then
			CreateTopTable "Search", GetTranslation("LANG_SEARCH")
			Response.Write "<table id=""SearchTable"" border=""0"" cellpadding=""0"" cellspacing=""0"">" & vbCRLF
			Response.Write "<form name=""rechercher"" method=""post"" action=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_SEARCH_PAGE & """>" & vbCRLF
			Response.Write " <tr>" & vbCRLF
			Response.Write "   <td colspan=""2"">" & vbCRLF
			Response.Write "        <select name=""section"" class=""cell"">" & vbCRLF
			If GLOBAL_NEWS_TOP > 0 Then
				Response.Write "		  <option value=""news"""
				If bSelected Then
					Response.Write " selected"
					bSelected = False
				End If
				Response.Write ">" & GetTranslation("LANG_NEWS") & "</option>" & vbCRLF
			End If
			If GLOBAL_DOWNLOADS_TOP > 0 Then
				Response.Write "		  <option value=""downloads"""
				If bSelected Then
					Response.Write " selected"
					bSelected = False
				End If
				Response.Write ">" & GetTranslation("LANG_DOWNLOADS") & "</option>" & vbCRLF
			End If
			If GLOBAL_ARTICLES_TOP > 0 Then
				Response.Write "		  <option value=""articles"""
				If bSelected Then
					Response.Write " selected"
					bSelected = False
				End If
				Response.Write ">" & GetTranslation("LANG_ARTICLES") & "</option>" & vbCRLF
			End If
			If GLOBAL_DIRECTORY_TOP > 0 Then
				Response.Write "		  <option value=""directory"""
				If bSelected Then
					Response.Write " selected"
					bSelected = False
				End If
				Response.Write ">" & GetTranslation("LANG_DIRECTORY") & "</option>" & vbCRLF
			End If
			If GLOBAL_IMAGES_TOP > 0 Then
				Response.Write "		  <option value=""images"""
				If bSelected Then
					Response.Write " selected"
					bSelected = False
				End If
				Response.Write ">" & GetTranslation("LANG_IMAGES") & "</option>" & vbCRLF
			End If
			Response.Write "		</select>" & vbCRLF
			Response.Write "   </td>" & vbCRLF
			Response.Write " </tr>" & vbCRLF
			Response.Write " <tr>" & vbCRLF
			Response.Write "   <td><input type=""text"" name=""r"" maxlength=""50"" size=""10"" class=""cell""></td>" & vbCRLF
			Response.Write "   <td><input type=""submit"" value=""" & GetTranslation("LANG_OK") & """ class=""button""></td>" & vbCRLF
			Response.Write " </tr>" & vbCRLF
			Response.Write "</form>" & vbCRLF
			Response.Write "</table>" & vbCRLF
			CreateBottomTable ""
		End If
	End Sub

	' Display some accounts' information
	' IN  : -
	' OUT : -
	Sub DisplayAccountsInfo()
		If bDisplayAccounts Then
			Dim oCn, oRs, rSQL

			CreateTopTable "Accounts", GetTranslation("LANG_ACCOUNTS")

			Set oCn = DBConnexion(DB_MAIN)
			rSQL = "SELECT Count(*) AS Nb FROM users"
			Set oRs = DBRecordSet(oCn, rSQL)

			Response.Write Replace(GetTranslation("LANG_ACCOUNTS_INFO"), "%1%", oRs(0))

			rSQL = "SELECT TOP 1 uLogin FROM users ORDER BY uDate DESC"
			Set oRs = DBRecordSet(oCn, rSQL)
			If Not oRs.EOF Then	Response.Write "<br><span class=""small"">" & GetTranslation("LANG_LAST_ACCOUNT") & " : <a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_PROFILE_PAGE & "?id=" & Server.URLEncode(oRs(0)) & """>" & Server.HTMLEncode(oRs(0)) & "</a><br>" & vbCRLF
			Response.Write "<a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_MEMBERSLIST_PAGE & """>" & GetTranslation("LANG_TITLE_MEMBERSLIST") & "</a></span>" & vbCRLF
			CreateBottomTable ""

			oCn.Close
			Set oCn = Nothing
			Set oRs = Nothing
		End If
	End Sub
	
	' Display the top last websites added to the directory
	' IN  : iTop (int) : number of results wanted
	' OUT : -
	Sub DisplayDirectoryLastSites(iTop)
		If bDisplayLastSites Then
			Dim oCn, oRs, rSQL

			Set oCn = DBConnexion(DB_MAIN)

			rSQL = "SELECT TOP " & iTop & " dID, dTitle, dDate, dURL, vCode FROM directory, versions WHERE dValid=1 AND dVersion=vID ORDER BY dDate DESC, dTitle"
			Set oRs = DBRecordSet(oCn, rSQL)

			If Not oRs.EOF Then
				CreateTopTable "TopDirectory", GetTranslation("LANG_TOP") & " - " & GetTranslation("LANG_SITES")
				While Not oRs.EOF
					Response.Write "  <span class=""small""><a href=""" & GLOBAL_SITE_PATH &  GLOBAL_SITE_GOTOURL_PAGE & "?url=" & Server.URLEncode(oRs("dURL")) & """ target=""_blank"">" & Server.HTMLEncode(oRs("dTitle")) & "</a> (" & Server.HTMLEncode(oRs("vCode")) & ")</span><br>" & vbCRLF
					oRs.MoveNext
				WEnd
				CreateBottomTable ""
			End If

			oCn.Close
			Set oCn = Nothing
			Set oRs = Nothing
		End If
	End Sub
	
	' Display versions languages available
	' IN  : -
	' OUT : -
	Sub DisplayVersions()
		If bDisplayVersions Then
			Dim oFs, oFolder, oFile, sVersion, sCurrentVersion
			
			Set oFs = Server.CreateObject("Scripting.FileSystemObject")
			
			If oFs.FolderExists(Server.MapPath(GLOBAL_SITE_VERSIONS_PATH)) Then
				sCurrentVersion = sXMLVersion
				If sCurrentVersion = "" Then sCurrentVersion = GLOBAL_SITE_DEFAULT_VERSION
				
				CreateTopTable "Versions", GetTranslation("LANG_VERSIONS")
				
				Response.Write "<script language=""javascript"" type=""text/javascript"">" & vbCRLF
				Response.Write "	function changeVersion()" & vbCRLF
				Response.Write "		{" & vbCRLF
				Response.Write "			document.VersionSetting.submit();" & vbCRLF
				Response.Write "		}" & vbCRLF
				Response.Write "</script>" & vbCRLF
				Response.Write "<table width=""100%"" border=""0"" cellpadding=""0"" cellspacing=""0"">" & vbCRLF
				Response.Write "<form method=""post"" name=""VersionSetting"" action=""" & sURLPage
				If Request.QueryString <> "" Then Response.Write "?" & Request.QueryString
				Response.Write """>" & vbCRLF
				Response.Write "	<tr>" & vbCRLF
				Response.Write "		<td align=""center"">" & vbCRLF

				Set oFolder = oFs.GetFolder(Server.MapPath(GLOBAL_SITE_VERSIONS_PATH))
				
				Response.Write "	<select name=""_SetCurrentVersion"" class=""cell"" onChange=""javascript:changeVersion()"">" & vbCRLF
				For Each oFile In oFolder.Files
					sVersion = Replace(oFile.Name, ".xml", "")
					Response.Write "		<option value=""" & sVersion & """"
					If LCase(sVersion) = LCase(sCurrentVersion) Then
						Response.Write " selected"
					End If
					Response.Write ">" & sVersion & "</option>" & vbCRLF
				Next
				Response.Write "	</select>" & vbCRLF
				Response.Write "		</td>" & vbCRLF
				Response.Write "	</tr>" & vbCRLF
				Response.Write "</form>" & vbCRLF
				Response.Write "</table>" & vbCRLF
				
				CreateBottomTable ""
			End If
		
			Set oFs = Nothing
		End If
	End Sub
	
	Sub DisplayNewPrivateMessages(sMyLogin)
		Dim oCn, oRs, rSQL, iNbMessages, iNbOldMessages, bDisplayPopup

		bDisplayPopup = False

		If sMyLogin <> "" Then

			Set oCn = DBConnexion(DB_MAIN)

			rSQL = "SELECT Count(*) FROM MessagesList WHERE mlTo='" & SQLEncrypt(sMyLogin) & "' AND mlRead=0"
			Set oRs = DBRecordSet(oCn, rSQL)
			iNbMessages = oRs(0)
		
			If iNbMessages > 0 Then
				iNbOldMessages = Request.Cookies("NewPrivateMessages")

				If iNbOldMessages = "" Then
					bDisplayPopup = True
				Else
					If IsNumeric(iNbOldMessages) Then
						iNbOldMessages = CInt(iNbOldMessages)
						If iNbMessages > iNbOldMessages Then bDisplayPopup = True
					End If
				End If
					
				If bDisplayPopup And InStr(sURLPage, GLOBAL_SITE_PRIVATE_MESSAGES_PAGE) = 0 Then
					Response.Write "<script language=""javascript"" type=""text/javascript"">window.open('" & GLOBAL_SITE_PATH & "newpmessage.asp', 'PrivateMessage', 'width=150, height=60, menubars=off');</script>"
				End If

				Response.Write " <a href=""" & GLOBAL_SITE_PATH & GLOBAL_SITE_PRIVATE_MESSAGES_PAGE & """><img src=""" & GLOBAL_SITE_IMAGES_PATH & "pmnew.gif"" border=""0"" alt=""" & GetTranslation("LANG_NEW_PRIVATE_MESSAGES") & """ hspace=""3""></a>"

				Response.Cookies("NewPrivateMessages") = CStr(iNbMessages)
			End If

			oCn.Close
			Set oCn = Nothing
			Set oRs = Nothing
		End If
	End Sub

	' Display one column, using a table containing a code for each bloc
	' IN  : tColumnContent (array) : table with index of blocs
	' OUT : -
	Sub DisplayColumn(tColumnContent)
		Dim X

		If IsArray(tColumnContent) Then
			For X = 0 to UBound(tColumnContent)
				Select Case CInt(tColumnContent(X))
					Case 0 : DisplayMenu()
					Case 1 : DisplayDynamicCounter()
					Case 2 : DisplayAccountsInfo()
					Case 3 : DisplaySearch()
					Case 4 : DisplayFavorites()
					Case 5 : DisplayDirectoryLastSites GLOBAL_DIRECTORY_TOP
					Case 6 : DisplayVersions()
					Case 7 : DisplayWebCounters()
					Case 8 : DisplayLastPoll()
					Case Else :
						DisplayCustomBlock(CInt(tColumnContent(X))-8)
				End Select
			Next
		End If
	End Sub
	
	Function GetTableAvailableColumns()
		Dim X, sTemp
		
		For X = 0 To 8 + GLOBAL_CUSTOM_BLOCKS
			If sTemp = "" Then
				sTemp = X
			Else
				sTemp = sTemp & "" & X
			End If
		Next

		GetTableAvailableColumns = Split(sTemp, "")
	End Function
%>