<%
'	************************************************************************
'	* ASP-Nuke: Free web portal in ASP                                     *
'	************************************************************************
'	* Copyright (c) 2002-2003 by Gaetan Bouveret (webmaster@asp-nuke.com)  *
'	* http://www.asp-nuke.com                                              *
'	*                                                                      *
'	* This program is free software. You can redistribute it and/or modify *
'	* it under the terms of the GNU General Public License as published by *
'	* the Free Software Foundation; either version 2 of the License, or    *
'	* (at your option) any later version.                                  *
'	*                                                                      *
'	************************************************************************
%>
<%
	' Gives the translation for a special tag
	' IN  : sTranslationKey (string) : tag's name
	' OUT : (string) : tag's translation
	Function GetTranslation(sTranslationKey)
		Dim sTranslationValue, oTranslation

		' oLangXML must be declared before (in the variables-inc.asp)
		sTranslationValue = sTranslationKey

		If Not oLangXML Is Nothing Then
			Set oTranslation = oLangXML.selectSingleNode("lang/translation[@name=""" & sTranslationKey & """]")
			If Not oTranslation Is Nothing Then 
				sTranslationValue = oTranslation.text
			End If
		End If
		
		GetTranslation = sTranslationValue
	End Function
	
	' Get the documentElement for the specified XML version
	' IN  : sVersionName (string) : version's name (as "FR", "EN", "NL", "IT" and so on)
	' OUT : (DOM.documentElement) : documentElement object containing the XML content
	Function GetXMLDocument(sVersionName)
		Dim oDom

		If sVersionName = "" Then sVersionName = GLOBAL_SITE_DEFAULT_VERSION

		Set oDom = Server.CreateObject("Microsoft.XMLDOM")
		oDom.async = False

		If oDom.Load(Server.MapPath(GLOBAL_SITE_VERSIONS_PATH & sVersionName & ".xml")) Then 
			Set GetXMLDocument = oDom.documentElement
		ElseIf oDom.Load(Server.MapPath(GLOBAL_SITE_VERSIONS_PATH & GLOBAL_SITE_DEFAULT_VERSION & ".xml")) Then 
			Set GetXMLDocument = oDom.documentElement
		Else
			Response.Write "Error : XML file is missing"
			Response.End
		End If

		Set oDom = Nothing
	End Function
	
	Function GetXMLAttribute(sAttribute)
		Dim oNode

		' oLangXML must be declared before (in the variables-inc.asp)

		If Not oLangXML Is Nothing Then
			Set oNode = oLangXML.selectSingleNode("lang")
			If Not oNode Is Nothing Then 
				GetXMLAttribute = oNode.getAttribute(sAttribute)
			End If
		End If
	End Function

	' Redirect to the authentication's page if user is not logged
	' IN  : -
	' OUT : -
	Sub MustBeLogged()
		If Request.Cookies("pseudo") = "" Then 
			Set oLangXML = Nothing
			Response.Redirect GLOBAL_SITE_PATH & GLOBAL_SITE_AUTHENTICATION_PAGE
			Response.End
		End If
	End Sub
	
	' Replace tags in a string (like HTML tags)
	' IN  : sMessage (string) : message to process
	'     : sTagHeader (string) : tag's header (like [url])
	'     : sTagFooter (string) : tag's footer (like [/url])
	'     : sPrefixConstraint (string) : prefix needed for the replacement (added if missing)
	'     : sReplacement (string) : replacement's text, can use %REPLACE% to take tag's content
	' OUT : (string) : text processed
	Function ReplaceTag(sSource, sTagHeader, sTagFooter, sPrefixConstraint, sReplacement)
		Dim iCurrent, iStart, iEnd, sTemp, sReplaced
		Dim iLenTagHeader, iLenTagFooter

		sTemp = ""
		iStart = 1		
		iEnd = 1
		iLenTagHeader = Len(sTagHeader)
		iLenTagFooter = Len(sTagFooter)

		iCurrent = InStr(iStart, LCase(sSource), LCase(sTagHeader))
		While iCurrent > 0
			iEnd = InStr(iCurrent, LCase(sSource), LCase(sTagFooter))
			If iEnd > 0 Then
				sReplaced = Mid(sSource, iCurrent+iLenTagHeader, iEnd-iCurrent-iLenTagHeader)
				' Check constraint
				If sPrefixConstraint <> "" Then
					If Left(LCase(sReplaced), Len(sPrefixConstraint)) <> LCase(sPrefixConstraint) Then sReplaced = sPrefixConstraint & sReplaced
				End If
				sTemp = sTemp & Mid(sSource, iStart, iCurrent-iStart) & Replace(sReplacement, "%REPLACE%", sReplaced)
				iEnd = iEnd + iLenTagFooter
				iCurrent = InStr(iEnd, LCase(sSource), LCase(sTagHeader))
				iStart = iEnd
			Else
				iCurrent = 0
			End If
		WEnd
		sTemp = sTemp & Mid(sSource, iStart, Len(sSource))
		ReplaceTag = sTemp
	End Function

	' Get smileys table from cache. Put them into cache if they need to
	' IN  : -
	' OUT : -
	Function GetSmileysTable()
		Dim oCn, oRs, rSQL, tSmileys(), X

		' Mise en cache des smileys, n'est excut qu'une fois
		If Not IsArray(Application("Smileys")) Then
			Set oCn = DBConnexion(DB_FORUM)
			rSQL = "SELECT Count(*) FROM Smileys"
			Set oRs = DBRecordSet(oCn, rSQL)
			X = oRs(0)
			Redim tSmileys(X-1, 1)
			rSQL = "SELECT * FROM Smileys ORDER BY SmileyTag"
			Set oRs = DBRecordSet(oCn, rSQL)
			X = 0
			While Not oRs.EOF
				tSmileys(X,0) = oRs("SmileyTag")
				tSmileys(X,1) = oRs("SmileyPath")
				X = X + 1
				oRs.MoveNext
			WEnd

			oCn.Close
			Set oRs = Nothing
			Set oCn = Nothing
				
			Application.Lock
			Application("Smileys") = tSmileys
			Application.UnLock
		End If
		
		GetSmileysTable = Application("Smileys")
	End Function
	
	' Prepare smileys : replace smileys to smileys tags ([smiley]:)[/smiley] for example)
	' IN  : sMessageToCode (string) : message to process
	' OUT : (string) : message processed
	Function PrepareSmileys(sMessageToCode)
		Dim sMessage, tSmileys, X

		sMessage = sMessageToCode
			
		If sMessage <> "" Then
			tSmileys = GetSmileysTable()

			For X = 0 To UBound(tSmileys)
				sMessage = Replace(sMessage, " " & tSmileys(X,0), " [smiley]" & tSmileys(X,0) & "[/smiley]")
			Next

			PrepareSmileys = sMessage
		End If
	End Function

	' Replace smileys with their images
	' IN  : sMessageToCode (string) : message to process
	' OUT : (string) : message processed
	Function ReplaceSmileys(sMessageToCode)
		Dim sMessage, tSmileys, X, sSmileyTemp

		sMessage = sMessageToCode
			
		If sMessage <> "" Then
			tSmileys = GetSmileysTable

			For X = 0 To UBound(tSmileys)
				sSmileyTemp = tSmileys(X,1)
				If Left(sSmileyTemp, 7) <> "http://" Then sSmileyTemp = GLOBAL_SITE_IMAGES_SMILEYS_PATH & sSmileyTemp
				sMessage = Replace(sMessage, "[smiley]" & tSmileys(X,0) & "[/smiley]", "<img src=""" & sSmileyTemp & """ border=""0"" alt=""" & Server.HTMLEncode(tSmileys(X,0)) & """>")
			Next

			ReplaceSmileys = sMessage
		End If
	End Function

	' Code message with special tags and can encode into HMTL
	' IN  : sMessageToCode (string) : message to process
	'     : bEncodeHTML (string) : True if you want to encode into HTML, False if not
	' OUT : (string) : text processed
	Function CodeMessage(sMessageToCode, bEncodeHTML)
		Dim sMessage

		sMessage = sMessageToCode

		CodeMessage = CodeMessageEx(sMessage, 0, bEncodeHTML, True)
	End Function

	' Code message for general purpose : display into top (part of the full message)
	' IN  : sMessageToCode (string) : message to process
	'     : iLen (int) : length of message returned, truncated at the next blank. If = 0 then no truncation
	'     : bEncodeHTML (boolean) : True if you want to encode into HTML, False if not
	'	  : bDisplaySmileys (boolean) : True if you want to use smileys
	' OUT : (string) : text processed
	Function CodeMessageEx(sMessageToCode, iLen, bEncodeHTML, bDisplaySmileys)
		Dim sMessage, iTrunc, bUseTags
		
		sMessage = sMessageToCode
		If sMessage <> "" Then
			If Len(sMessage) > iLen and iLen > 0 Then
				iTrunc = InStr(iLen, sMessage, " ", 1)
				If iTrunc = 0 or IsNull(iTrunc) Then 
					iTrunc = iLen
				Else
					If iTrunc > Round(iLen*1.5) Then iTrunc = iLen
				End If
				sMessage = Left(sMessage, iTrunc-1) & "..."
			End If

			If bDisplaySmileys Then sMessage = PrepareSmileys(sMessage)
			If bEncodeHTML Then sMessage = Server.HTMLEncode(sMessage)
			If iLen = 0 Then 
				sMessage = Text2HTML(sMessage)
				sMessage = ReplaceTag(sMessage, "[img]", "[/img]", "http://", "<img src=""%REPLACE%"" border=""0"">")
				sMessage = ReplaceTag(sMessage, "[url]", "[/url]", "http://", "<a href=""%REPLACE%"" target=""_blank"">%REPLACE%</a>")
				sMessage = ReplaceTag(sMessage, "[cit]", "[/cit]", "", "<blockquote><div class=""myQuote"">%REPLACE%</div></blockquote>")
				sMessage = ReplaceTag(sMessage, "[b]", "[/b]", "", "<b>%REPLACE%</b>")
				sMessage = ReplaceTag(sMessage, "[i]", "[/i]", "", "<i>%REPLACE%</i>")
				sMessage = ReplaceTag(sMessage, "[u]", "[/u]", "", "<u>%REPLACE%</u>")
				sMessage = ReplaceTag(sMessage, "[s]", "[/s]", "", "<s>%REPLACE%</s>")
			End If
			If bDisplaySmileys Then sMessage = ReplaceSmileys(sMessage)
		End If

		CodeMessageEx = sMessage
	End Function

	' Convert a Date to a string
	' IN  : dDate (date) : source
	' OUT : (string) : destination (format YYYYMMDD)
	Function DateToString(dDate)
		DateToString = Year(dDate) & Right("0" & Month(dDate), 2) & Right("0" & Day(dDate), 2)
	End Function

	' Convert a DateTime to a string
	' IN  : dDateTime (datetime) : source
	' OUT : (string) : destination (format YYYYMMDD HH:MM:SS)
	Function DateTimeToString(dDateTime)
		DateTimeToString = Year(dDateTime) & Right("0" & Month(dDateTime), 2) & Right("0" & Day(dDateTime), 2) & " " & Right("0" & Hour(dDateTime), 2) & ":" & Right("0" & Minute(dDateTime), 2) & ":" & Right("0" & Second(dDateTime), 2)
	End Function

	' Convert a Time to a string
	' IN  : dTime (time) : source
	' OUT : (string) : destination (format HH:MM:SS)
	Function TimeToString(dTime)
		TimeToString = Right("0" & Hour(dTime), 2) & ":" & Right("0" & Minute(dTime), 2) & ":" & Right("0" & Second(dTime), 2)
	End Function

	' Convert a string to a date or datetime
	' IN  : sDate (string) : source (format YYYYMMDD HH:MM:SS or YYYYMMDD)
	' OUT : (datetime) : destination
	Function StringToDate(sDate)
		Dim dDate
		dDate = DateSerial(Left(sDate, 4), Mid(sDate, 5, 2), Mid(sDate, 7, 2))
		If Len(sDate) > 8 Then dDate = dDate + TimeSerial(Mid(sDate, 10, 2), Mid(sDate, 13, 2), Mid(sDate, 16, 2))
		StringToDate = dDate
	End Function

	' Get a date to display with a special formatting : Day Monthname Year
	' IN  : dDate (datetime) : source
	' OUT : (string) : destination
	Function GetDateLitteralDDMMYYYY(dDate)
		Dim sTemp
		
		sTemp = GetXMLAttribute("date_format_text") ' DATE_FORMAT_TEXT

		' Day replacement
		sTemp = Replace(sTemp, "DD", Right("0" & Day(dDate), 2))
		' Monthname replacement
		sTemp = Replace(sTemp, "MN", MonthName(Month(dDate)))
		' Month replacement
		sTemp = Replace(sTemp, "MM", Right("0" & Month(dDate), 2))
		' Year replacement
		sTemp = Replace(sTemp, "YYYY", Year(dDate))

		GetDateLitteralDDMMYYYY = sTemp
	End Function

	' Get a date to display with a special formatting : Day Monthname Year at Hour Minute Second
	' IN  : dDate (datetime) : source
	' OUT : (string) : destination
	Function GetDateLitteralDDMMYYYYHHMMSS(dDateTime)
		Dim sTemp

		sTemp = GetXMLAttribute("date_time_format_text") ' DATE_TIME_FORMAT_TEXT

		' Day replacement
		sTemp = Replace(sTemp, "DD", Right("0" & Day(dDateTime), 2))
		' Monthname replacement
		sTemp = Replace(sTemp, "MN", MonthName(Month(dDateTime)))
		' Month replacement
		sTemp = Replace(sTemp, "MM", Right("0" & Month(dDateTime), 2))
		' Year replacement
		sTemp = Replace(sTemp, "YYYY", Year(dDateTime))
		' Hour replacement
		sTemp = Replace(sTemp, "hh", Right("0" & Hour(dDateTime), 2))
		' Minute replacement
		sTemp = Replace(sTemp, "mm", Right("0" & Minute(dDateTime), 2))
		' Second replacement
		sTemp = Replace(sTemp, "ss", Right("0" & Second(dDateTime), 2))
	
		GetDateLitteralDDMMYYYYHHMMSS = sTemp
	End Function

	' Get a date to display with a special formatting : Day/Month/Year, year on 2 digits
	' IN  : dDate (datetime) : source
	' OUT : (string) : destination
	Function GetDateDDMMYY(dDate)
		Dim sTemp
		
		sTemp = GetXMLAttribute("date_format") ' DATE_FORMAT
		
		' Day replacement
		sTemp = Replace(sTemp, "DD", Right("0" & Day(dDate), 2))
		' Month replacement
		sTemp = Replace(sTemp, "MM", Right("0" & Month(dDate), 2))
		' Year replacement
		sTemp = Replace(sTemp, "YYYY", Right(Year(dDate), 2))

		GetDateDDMMYY = sTemp
	End Function

	' Get a date to display with a special formatting : Day/Month/Year, year on 4 digits
	' IN  : dDate (datetime) : source
	' OUT : (string) : destination
	Function GetDateDDMMYYYY(dDate)
		Dim sTemp
		
		sTemp = GetXMLAttribute("date_format") ' DATE_FORMAT
		
		' Day replacement
		sTemp = Replace(sTemp, "DD", Right("0" & Day(dDate), 2))
		' Month replacement
		sTemp = Replace(sTemp, "MM", Right("0" & Month(dDate), 2))
		' Year replacement
		sTemp = Replace(sTemp, "YYYY", Year(dDate))

		GetDateDDMMYYYY = sTemp
	End Function

	' Get a date to display with a special formatting : DATE_FORMAT and TIME_FORMAT
	' IN  : dDate (datetime) : source
	' OUT : (string) : destination
	Function GetDateDDMMYYHHMMSS(dDateTime)
		Dim sTemp
		
		sTemp = GetXMLAttribute("date_format") & " " & GetXMLAttribute("time_format") ' DATE_FORMAT & " " & TIME_FORMAT
		
		' Day replacement
		sTemp = Replace(sTemp, "DD", Right("0" & Day(dDateTime), 2))
		' Month replacement
		sTemp = Replace(sTemp, "MM", Right("0" & Month(dDateTime), 2))
		' Year replacement
		sTemp = Replace(sTemp, "YYYY", Right("0" &Year(dDateTime), 2))
		' Hour replacement
		sTemp = Replace(sTemp, "hh", Right("0" & Hour(dDateTime), 2))
		' Minute replacement
		sTemp = Replace(sTemp, "mm", Right("0" & Minute(dDateTime), 2))
		' Second replacement
		sTemp = Replace(sTemp, "ss", Right("0" & Second(dDateTime), 2))

		GetDateDDMMYYHHMMSS = sTemp
	End Function

	' Encrypt string to be javascript compliant
	' IN  : sText (string) : text to process
	' OUT : (string) : text processed
	Function JsEncrypt(sText)
		JsEncrypt = Replace(Replace(sText, "'", "\'"), """", "\""")
	End Function

	' Display the menu for sort table results
	' IN  : sFieldName (string) : target field name
	'     : sField (string) : target field
	'     : sSortedField (string) : field currently sorted
	'     : bAscSort (boolean) : if True then ASC sort, else DESC
	' OUT : -
	Sub SortMenu(sFieldName, sField, sSortedField, bAscSort)
		Dim bSame
		
		bSame = LCase(sSortedField) = LCase(sField)
		
		Response.Write sFieldName & " <span class=""small"">(<a href=""" & sURLPage & "?sort=" & sField & "&sortype=asc"">"
		If bSame and bAscSort Then 
			Response.Write "<b>A</b>"
		Else
			Response.Write "A"
		End If
		Response.Write "</a>/<a href=""" & sURLPage & "?sort=" & sField & "&sortype=desc"">"
		If bSame and Not bAscSort Then 
			Response.Write "<b>D</b>"
		Else
			Response.Write "D"
		End If
		Response.Write "</a>)</span>"
	End Sub

	' Change HTML to text
	' IN  : sText (string) : text to process
	' OUT : (string) : text processed
	Function HTML2Text(sText)
		If sText <> "" Then
			Dim sTemp
			sTemp = sText
			HTML2Text = Replace(sTemp, "<br>", vbCRLF)
		Else
			HTML2Text = sText
		End If
	End Function

	' Change text to HMTL
	' IN  : sText (string) : text to process
	' OUT : (string) : text processed
	Function Text2HTML(sText)
		If sText <> "" Then
			Dim sTemp
			sTemp = sText
			Text2HTML = Replace(sTemp, vbCRLF, "<br>")
		Else
			Text2HTML = sText
		End If
	End Function
	
	' Return is user is authorized to access to a special part of the site
	' IN  : iAccessRole (int) : minimum level's access
	' OUT : (boolean) : True if authorized, False if not
	Function IsAuthorized(iAccessRole)
		IsAuthorized = False
		If iRole >= iAccessRole Then IsAuthorized = True
	End Function

	' Redirect to default page if user is not authorized to access to a special part of the site
	' IN  : iAccessRole (int) : minimum level's access
	' OUT : -
	Sub AccessOnly(iAccessRole)
		If Not IsAuthorized(iAccessRole) Then
			Set oLangXML = Nothing
			Response.Redirect GLOBAL_SITE_PATH & "Default.asp"
			Response.End
		End If
	End Sub
%>