<%
	' Set LCID
	' IN  : -
	' OUT : (string) Last visit date (string format)
	Sub SetLCID()
		On Error Resume Next
		Session.LCID = GetXMLAttribute("lcid")
		If Err.number <> 0 Then Err.Clear
		On Error Goto 0
	End Sub
	
	Sub ManageLeftAndRightColumn()
		Dim myLeftColumn, myRightColumn, myCustomBlocks, bUpdateApplicationBlocks, bGetDefault
		
		bGetDefault = True
		bUpdateApplicationBlocks = False

		myLeftColumn = Request.Cookies("myLeftColumn")
		myRightColumn = Request.Cookies("myRightColumn")
		myCustomBlocks = Request.Cookies("myCustomBlocks")

		If IsEmpty(Application("myLeftColumn")) And IsEmpty(Application("myRightColumn")) Then
			bUpdateApplicationBlocks = True
		ElseIf Application("myCustomBlocks") <> CStr(GLOBAL_CUSTOM_BLOCKS) Then
			bUpdateApplicationBlocks = True
		End If
		
		If bUpdateApplicationBlocks	Then
			Application.Lock()
			Application("myLeftColumn") = GetTableAvailableColumns()
			Application("myRightColumn") = ""
			Application("myCustomBlocks") = CStr(GLOBAL_CUSTOM_BLOCKS)
			Application.UnLock()
		End If

		If (myLeftColumn <> "" or myRightColumn <> "") and (myCustomBlocks <> "") Then
			If myCustomBlocks = CStr(GLOBAL_CUSTOM_BLOCKS) Then
				If myLeftColumn <> "" Then 
					tLeftColumn = Split(myLeftColumn, "")
				Else
					tLeftColumn = ""
				End If
				If myRightColumn <> "" Then 
					tRightColumn = Split(myRightColumn, "")
				Else
					tRightColumn = ""
				End If

				bGetDefault = False
			End If
		End If

		If bGetDefault then
			' Default design
			tLeftColumn = Application("myLeftColumn")
			tRightColumn = Application("myRightColumn")
		End If
	End Sub

	' Return the last visit date and set it into cookie
	' IN  : -
	' OUT : (string) Last visit date (string format)
	Function GetAndSetLastVisit()
		Dim myLastVisit

		myLastVisit = Request.Cookies("CurrentLastVisit")
		If myLastVisit = "" Then
			If Request.Cookies("LastVisit") <> "" Then
				myLastVisit = Request.Cookies("LastVisit")
				Response.Cookies("LastVisit") = DateTimeToString(Now())
				Response.Cookies("LastVisit").Expires = Date + 365
				Response.Cookies("CurrentLastVisit") = myLastVisit
			Else
				myLastVisit = "20000101 01:00:00"
				Response.Cookies("LastVisit") = myLastVisit
				Response.Cookies("LastVisit").Expires = Date + 365
				Response.Cookies("CurrentLastVisit") = myLastVisit
			End If
		End If
		
		GetAndSetLastVisit = myLastVisit
	End Function
	
	' Return the current theme and set it into cookie
	' IN  : -
	' OUT : (string) Theme's name
	Function GetAndSetTheme()
		Dim myTheme

		If Request.Form("CurrentTheme") <> "" Then
			myTheme = Request.Form("CurrentTheme")
			Response.Cookies("CurrentTheme") = myTheme
			Response.Cookies("CurrentTheme").Expires = Date + 365
		Else
			If Request.Cookies("CurrentTheme") <> "" Then
				myTheme = Request.Cookies("CurrentTheme") 
			Else
				myTheme = "default"
			End If
		End If
		
		GetAndSetTheme = myTheme
	End Function

	' Get the current version and set it into cookie
	' IN  : -
	' OUT : (string) charset's id
	Function GetAndSetXMLVersion()
		Dim myXMLVersion

		If Request.Form("_SetCurrentVersion") <> "" Then
			myXMLVersion = Request.Form("_SetCurrentVersion")
			Response.Cookies("CurrentVersion") = myXMLVersion
			Response.Cookies("CurrentVersion").Expires = Date + 365
		Else
			myXMLVersion = Request.Cookies("CurrentVersion")
			If myXMLVersion = "" Then
				myXMLVersion = GLOBAL_SITE_DEFAULT_VERSION
				Response.Cookies("CurrentVersion") = myXMLVersion
				Response.Cookies("CurrentVersion").Expires = Date + 365
			End If
		End If
		
		GetAndSetXMLVersion = myXMLVersion
	End Function
	
	' Return the charset
	' IN  : -
	' OUT : (string) charset's id
	Function GetCharset()
		Dim myCharset

		If GetXMLAttribute("charset") <> "" Then 
			myCharset = GetXMLAttribute("charset")
		Else
			myCharset = "iso-8859-1"
		End If
		
		GetCharset = myCharset
	End Function

%>